<?php
/*
    "NuSOAP and WSDL"
    http://www.nonplus.net/geek/000752.php

    Copyright 2003, Stepan Riha, All right reserved.

    You're free to make derivative and commercial use of this code
    without attribution.

    Version 2.0 - Oct 29, 2003
    Fixed problems with unquoted string constants.

*/
require_once('config/cfg.php');
require ("constants.php");

//apache htaccess - www authentication
if ( ( !isset( $PHP_AUTH_USER )) || (!isset($PHP_AUTH_PW))  
     || ( $PHP_AUTH_USER != $htaccessUser ) || ( $PHP_AUTH_PW != $htaccessPassword ) ) { 
    header( 'WWW-Authenticate: Basic realm="Private"' ); 
    header( 'HTTP/1.0 401 Unauthorized' ); 
    echo "This folder is protected "; 
    exit; 
} 

//$NAMESPACE = 'urn:Callware';
$NAMESPACE = 'urn:Callware';
$server = new soap_server;

$server->debug_flag=false;
$server->configureWSDL('Callware', $NAMESPACE);
$server->wsdl->schemaTargetNamespace = $NAMESPACE;

$db->SetFetchMode(ADODB_FETCH_ASSOC);

// ==== WSDL TYPES DECLARATION =================================================

include ("structs.php");

// ==== WSDL METHODS REGISTRATION ==============================================

$server->register(
    'getClient',
    array('id'=>'xsd:int', 'prot'=>'xsd:int'),
    array('return'=>'tns:ClientArray'),
    $NAMESPACE);

$server->register(
    'putClient',
    array('client'=>'tsn:Client'),
    array('return'=>'xsd:int'),
    $NAMESPACE);


$server->register(
    'delClient',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);
    
$server->register(
    'getDepartment',
    array('id'=>'xsd:int'),
    array('return'=>'tns:DepartmentArray'),
    $NAMESPACE);

$server->register(
    'putDepartment',
    array('dep'=>'tsn:Department'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'delDepartment',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'getResource',
    array('id'=>'xsd:int', 'type'=>'xsd:int'),
    array('return'=>'tns:ResourceArray'),
    $NAMESPACE);

$server->register(
    'putResource',
    array('res'=>'tsn:Resource'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'delResource',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);
    
$server->register(
    'getPhoneNumber',
    array('id'=>'xsd:int'),
    array('return'=>'tns:PhoneNumberArray'),
    $NAMESPACE);

$server->register(
    'putPhoneNumber',
    array('number'=>'tsn:PhoneNumber'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'delPhoneNumber',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);
    
$server->register(
    'getGroup',
    array('id'=>'xsd:int', 'type'=>'xsd:int'),
    array('return'=>'tns:GroupArray'),
    $NAMESPACE);
    
$server->register(
    'putGroup',
    array('group'=>'tsn:Group'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'delGroup',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'getRight',
    array('id'=>'xsd:int'),
    array('return'=>'tns:RightArray'),
    $NAMESPACE);
    
$server->register(
    'putRight',
    array('right'=>'tsn:Right'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'delRight',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'getApplication',
    array('id'=>'xsd:int'),
    array('return'=>'tns:ApplicationArray'),
    $NAMESPACE);

$server->register(
    'getQueue',
    array('id'=>'xsd:int'),
    array('return'=>'tns:QueueArray'),
    $NAMESPACE);
    
$server->register(
    'putQueue',
    array('queue'=>'tsn:Queue'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'delQueue',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'getIvrNode',
    array('id'=>'xsd:int', 'cascading'=>'xsd:boolean'),
    array('return'=>'tns:IvrNodeArray'),
    $NAMESPACE);
    
$server->register(
    'putIvrNode',
    array('queue'=>'tsn:IvrNode'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'delIvrNode',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'getIvr',
    array('id'=>'xsd:int'),
    array('return'=>'tns:IvrArray'),
    $NAMESPACE);

$server->register(
    'putIvr',
    array('ivr'=>'tsn:Ivr'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'delIvr',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);
    
$server->register(
    'compileIvr',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'getCard',
    array('id'=>'xsd:int'),
    array('return'=>'tns:CardArray'),
    $NAMESPACE);
    
$server->register(
    'putCard',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'delCard',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);
    

$server->register(
    'getPort',
    array('id'=>'xsd:int'),
    array('return'=>'tns:PortArray'),
    $NAMESPACE);

$server->register(
    'updatePort',
    array('ports'=>'tns:PortArray'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'getOption',
    array('id'=>'xsd:int','category'=>'xsd:string'),
    array('return'=>'tns:OptionArray'),
    $NAMESPACE);
    
$server->register(
    'getOptionByName',
    array('id'=>'xsd:string','category'=>'xsd:string'),
    array('return'=>'tns:OptionArray'),
    $NAMESPACE);
    
$server->register(
    'putOption',
    array('option'=>'tsn:OptionArray'),
    array('return'=>'xsd:int'),
    $NAMESPACE);
    
$server->register(
    'getIsdnGroup',
    array('id'=>'xsd:int'),
    array('return'=>'tns:IsdnGroupArray'),
    $NAMESPACE);

$server->register(
    'putIsdnGroup',
    array('group'=>'tns:IsdnGroup'),
    array('return'=>'xsd:int'),
    $NAMESPACE);
    
$server->register(
    'delIsdnGroup',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'getAction',
    array('id'=>'xsd:int'),
    array('return'=>'tns:ActionArray'),
    $NAMESPACE);

$server->register(
    'getIsdnPhoneNumber',
    array('id'=>'xsd:int'),
    array('return'=>'tns:IsdnPhoneNumberArray'),
    $NAMESPACE);

$server->register(
    'updateIsdnPhoneNumber',
    array('numbers'=>'tns:IsdnPhoneNumberArray'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

    
$server->register(
    'writeMIsdn',
    array(),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'writeSIP',
    array(),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'writeIAX',
    array(),
    array('return'=>'xsd:int'),
    $NAMESPACE);
    
$server->register(
    'updateNetwork',
    array('option'=>'tns:stringArray'),
    array('return'=>'xsd:int'),
    $NAMESPACE);
    
$server->register(
    'getDirectory',
    array(),
    array('return'=>'tns:DirectoryArray'),
    $NAMESPACE);
    
$server->register(
    'initialize',
    array('genKeys' => 'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);
    
$server->register(
    'getUser',
    array('id'=>'xsd:int'),
    array('return'=>'tns:UserArray'),
    $NAMESPACE);

$server->register(
    'putUser',
    array('user'=>'tns:User'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'checkUser',
    array('username'=>'xsd:string','password'=>'xsd:string'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'delUser',
    array('id'=>'xsd:int'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'createAstConfig',
    array('lines'=>'tns:stringArray','filename'=>'xsd:string'),
    array('return'=>'xsd:int'),
    $NAMESPACE);

$server->register(
    'viewAstConfigFilename',
    array(),
    array('return'=>'tns:stringArray'),
    $NAMESPACE);

$server->register(
    'viewAstConfig',
    array('filename'=>'xsd:string'),
    array('return'=>'xsd:string'),
    $NAMESPACE);

$server->register(
    'getPublicKey',
    array(),
    array('return'=>'xsd:string'),
    $NAMESPACE);

$server->register(
    'getVoiceMail',
    array('id'=>'xsd:int'),
    array('return'=>'tns:VoiceMailArray'),
    $NAMESPACE);

$server->register(
    'putVoiceMail',
    array('voicemail'=>'tns:VoiceMail'),
    array('return'=>'xsd:int'),
    $NAMESPACE);
    
$server->register(
    'stats',
    //array('source'=>'xsd:string','type'=>'xsd:string','search'=>'xsd:string','from'=>'xsd:string','to'=>'xsd:string','orderBy'=>'xsd:string','page'=>'xsd:int'),
    array('request'=>'tns:CdrRequest'),
    array('return'=>'tns:CdrArray'),
    $NAMESPACE); 
    
    
    
// ==== PROCESS REQUEST ========================================================

$HTTP_RAW_POST_DATA = isset($GLOBALS['HTTP_RAW_POST_DATA'])
                        ? $GLOBALS['HTTP_RAW_POST_DATA'] : '';
$server->service($HTTP_RAW_POST_DATA);
exit();


// ==== METHOD IMPLEMENTATION ==================================================


//******************************************************************************
//******************               PEER                     ********************
//******************************************************************************


// ---- getPeer(id:int, prot:int):peer[] ---------------------------------------
function getPeer($id,$prot) {
  global $db;
  
  if ($id!="") $condition=" WHERE id=$id ";
  if ($prot==SIP_PROTOCOL or $prot=="") {
    $qry="SELECT * FROM sip_buddies $condition";
    $res=$db->Execute($qry);
    while ($arr=$res->FetchRow()) { 
      //$arr["ports"]=$arr["port"]; //added this line for an unknown NuSoap Bug
      if (!is_numeric($arr["port"])) $arr["port"]="";
      if (!is_numeric(str_replace(".","",$arr["ipaddr"]))) $arr["ipaddr"]="";
      $arr["protocol"]=SIP_PROTOCOL;
      $ret[]=$arr;
    }
  }
  if ($prot==IAX_PROTOCOL or $prot=="") {
    $qry="SELECT * FROM iax_buddies $condition";
    $res=$db->Execute($qry);
    while ($arr=$res->FetchRow()) { 
      $arr["protocol"]=IAX_PROTOCOL;
      $ret[]=$arr;
    }
  }
  return $ret;
}

// ---- putPeer(entry:peer):int ------------------------------------------------

function putPeer($peer) {
  global $db;
  
  //go to the alterPeer function
  if (isset($peer["id"]) and $peer["id"]!="") return alterPeer($peer);

  if ($peer["protocol"]==SIP_PROTOCOL) $table="sip_buddies";
  elseif ($peer["protocol"]==IAX_PROTOCOL) $table="iax_buddies";
  else return 0;

  //$peer["port"]=$peer["ports"]; //added this line for an unknown NuSoap Problem
  $fields=$db->MetaColumnNames($table);
  foreach ($fields as $f) {
    if (array_key_exists($f,$peer)) {
      $field_list.="$f,";
      if (is_int($peer[$f])) $value_list.=$peer[$f].",";
      else  $value_list.="'".$peer[$f]."',";
    }
  }  
  $field_list=substr($field_list,0,-1);
  $value_list=substr($value_list,0,-1);
  
  //check if already exists the same id or name
  $qry="SELECT * FROM $table WHERE id='".$peer["id"]."' or name='".$peer["name"]."'";

  $res=$db->Execute($qry);
  if ($res->RecordCount()>0) return 0;
  
  //insert the row
  $qry="INSERT INTO $table ($field_list) VALUES ($value_list)";
  $res=$db->Execute($qry);
  if ($res===false) $ret=0; else $ret=$db->Insert_ID();
  return $ret;
}

// ---- alterPeer(entry:peer):int ------------------------------------------------
// ---- the id value is requested

function alterPeer($peer) {
  global $db;

  if ($peer["protocol"]==SIP_PROTOCOL) $table="sip_buddies";
  elseif ($peer["protocol"]==IAX_PROTOCOL) $table="iax_buddies";
  else return 0;

  $fields=$db->MetaColumnNames($table);
  foreach ($fields as $f) {
    if (@array_key_exists($f,$peer) and $f!="id" ) {
      if (is_int($peer[$f])) $value_list.="$f=".$peer[$f].",";
      else  $value_list.="$f='".$peer[$f]."',";
    }
  }  
  $value_list=substr($value_list,0,-1);

  //check if already exists the same id or name
  if ($peer["id"]=="") return 0;

  //insert the row
  $qry="UPDATE $table SET $value_list WHERE id=".$peer["id"];

  $res=$db->Execute($qry);
  if ($res===false) $ret=0; else $ret=$peer["id"];
  return $ret;
}

// ---- delPeer(id:int, prot:int):int ------------------------------------------

function delPeer($id,$prot) {
  global $db;
  
  if ($id!="") $condition=" WHERE id=$id ";  else return 0;
  if ($prot=="") return 0;
  
  if ($prot==SIP_PROTOCOL) $table="sip_buddies";
  else if ($prot==IAX_PROTOCOL) $table="iax_buddies";
  else return 0;

  //check if already exists the same id
  $qry="SELECT * FROM $table WHERE id='$id'";
  $res=$db->Execute($qry);
  if ($res->RecordCount()==0) return 0;

  //delete extension
  $qry="DELETE FROM $table $condition";
  $res=$db->Execute($qry);
  if ($res===false) $ret=0; else $ret=1;
  return $ret;
}

//******************************************************************************
//******************               EXTENSION                ********************
//******************************************************************************

// ---- getExtension(id:int):extension[] ---------------------------------------

function getExtension($id) {
  global $db;
  
  if ($id!="") $condition=" WHERE id=$id ";  
  else $condition="";
  
  $table="extensions_table";
  
  $qry="SELECT * FROM $table $condition";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) { 
    $ret[]=$arr;
  }
  return $ret;
}

// ---- putExtension(entry:extension):int --------------------------------------

function putExtension($extension) {
  global $db;
  
  $table="extensions_table";
  $fields=$db->MetaColumnNames($table);
  foreach ($fields as $f) {
    if (array_key_exists($f,$extension) and $f!="id") {
      $field_list.="$f,";
      if (is_int($extension[$f])) $value_list.=$extension[$f].",";
      else  $value_list.="'".$extension[$f]."',";
    }
  }  
  $field_list=substr($field_list,0,-1);
  $value_list=substr($value_list,0,-1);
  
  //check if already exists the same id or name
  /*
  $qry="SELECT * FROM $table WHERE id='".$extension["id"]."' or exten='".$extension["exten"]."'";
  $res=$db->Execute($qry);
  if ($res->RecordCount()>0) return new soap_fault('Client','','put Extension, extension name already exists');;
  */
  
  //insert the row
  $qry="INSERT INTO $table ($field_list) VALUES ($value_list)";
  $res=$db->Execute($qry);
  if ($res===false) $ret=0; else $ret=$db->Insert_ID();

  return $ret;
}

// ---- delExtension(id:int):int -----------------------------------------------

function delExtension($id) {
  global $db;

  if ($id!="") $condition=" WHERE id=$id ";  else return 0;
  $table="extensions_table";
  
  //check if already exists the same id
  $qry="SELECT * FROM $table WHERE id='$id'";
  $res=$db->Execute($qry);
  if ($res->RecordCount()==0) return 0;

  //delete extension
  $qry="DELETE FROM $table $condition";
  $res=$db->Execute($qry);
  if ($res===false) $ret=0; else $ret=1;
  return $ret;
}

// ---- getExtensionType(id:int, technology:int):extensiontype[] ---------------

function getExtensionType($id,$technology=0) {
  global $db;
  
  if ($id!="") $condition=" WHERE id=$id ";  
  else $condition="";
  
  $table="cw_extension_type";
  
  $qry="SELECT * FROM $table $condition";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) { 
    $ret[]=$arr;
  }
  return $ret;
}

// ---- generateExtension(context:int, extension:string, priority: int, extensionType:int, value:string):extension ------------
//      private function
function generateExtension($context,$extension,$priority,$extensionType,$value=null) {
  global $db;
  
  $rawExtensionArray=getExtensionType($extensionType);
  $rawExtension=$rawExtensionArray[0];
  switch ($extensionType) {
    //Sip Primary extension
    case SIP_CLIENT_EXTENSION:
      $extensionName=$value;
      $appdata=str_replace("\$extension",$value,$rawExtension["appdata"]);
      break;
    //Sip Alias extension
    case SIP_CLIENT_NICKNAME:
      $extensionName=$extension;
      $appdata=str_replace("\$extension",$value,$rawExtension["appdata"]);
      break;
    //Iax Department extension
    case IAX_DEP_EXTENSION:
      $extensionName=$extension;
      $appdata=str_replace("\$name",$value,$rawExtension["appdata"]);
      break;
    //Iax Department Alias extension
    case IAX_DEP_NICKNAME:
      $extensionName=$extension."*";
      $appdata=str_replace("\$name",$value,$rawExtension["appdata"]);
      break;
    //Iax Department Alias+ext extension
    case IAX_DEP_NICKNAME2:
      $extensionName="_".$extension."*.";
      $appdata=str_replace("\$name",$value,$rawExtension["appdata"]);
      break;
    case SIP_RESOURCE_EXTENSION:
      $extensionName="_".$extension."*.";
      $appdata=str_replace("\$len",strlen($extension)+1,$rawExtension["appdata"]);
      $appdata=str_replace("\$name",$value,$appdata);
      break;
    case ISDN_RESOURCE_EXTENSION:
      $extensionName="_".$extension."*.";
      $appdata=str_replace("\$name",$value,$rawExtension["appdata"]);
      break;
    case PHONENUMBER_EXTENSION:
    case PHONENUMBER_EMERGENCY_EXTENSION:
      $extensionName=$extension;
      $appdata=$rawExtension["appdata"];
      break;
  }
  $extensionArray["context"]=$context;
  $extensionArray["exten"]=$extensionName;
  $extensionArray["priority"]=$priority;
  $extensionArray["app"]=$rawExtension["app"];
  $extensionArray["appdata"]=$appdata;
  $extensionArray["type"]=$extensionType;

  return $extensionArray;
}

// ---- putEntityToAsterisk(entity_id: int, extensions:ExtensionArray, groups:intArray, peer:Peer):int

function putEntityToAsterisk($entity_id,$extensions,$groups,$value) {
  global $db;
  $ret=1;
  
  //create the entry in the ast_config
  $context=$value;
  $res=putAstConfig("extensions.conf", $context, "switch", "Realtime/@extensions");
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  //insert the entries in extensions_table
  if (is_array($extensions)) 
  foreach ($extensions as $v) {
    $e=generateExtension($context,$v["exten"],$v["priority"],$v["type"],$value);
    $extension_id=putExtension($e);
    $extension_type=$e["type"];
    if ($extension_id>0 and !is_object($extension_id)) {
      $qry="INSERT INTO cw_entity_extensions (entity_id, extension_id, type) VALUES ($entity_id, $extension_id, $extension_type)";
      $res=$db->Execute($qry);
      if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
    }
  }

  //add the extensions in extensions table and note it into the entity_extensions table
  if (is_array($groups)) 
  foreach ($groups as $g) {
    $groupArr=getGroup($g);
    $includeContext=$groupArr[0]["name"];
    $res=putAstConfig("extensions.conf", $includeContext, "include", $context);
    if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
  }

  //add this entity to the choosed groups
  $res=entityToGroups($entity_id,$groups);
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  return $ret;
}

// ---- delEntityFromAsterisk(entity_id: int):int

function delEntityFomAsterisk($entity_id) {
  global $db,$groupPrefix;

  $entityName=getEntityName($entity_id);
  //cancello il client
  //$qry="DELETE FROM cw_number WHERE id=".$entity_id;
  //$db->Execute($qry);
  
  //recupero le estensioni legate a questa entity e le cancello
  $qry="SELECT * FROM cw_entity_extensions WHERE entity_id=$entity_id";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) {
    $db->Execute("DELETE FROM extensions_table WHERE id=".$arr["extension_id"]);
  }        
  $db->Execute("DELETE FROM cw_entity_extensions WHERE entity_id=$entity_id");
  $db->Execute("DELETE FROM cw_group_entity WHERE entity_id=$entity_id");
  
  $res=delAstConfig("extensions.conf","%","include",$entityName);
  $res=delAstConfig("extensions.conf",$entityName,"switch");

  //regenerate the global var from the ast config 
  generateGlobalVar();  
  
  $ret=delEntity($entity_id);
  return $ret;
}

//******************************************************************************
//******************               ENTITY                   ********************
//******************************************************************************

// ---- getEntity(id:int):entity[] ---------------------------------------------

function getEntity($id) {
  global $db;
  //syncEntities();
  if ($id!="") $condition=" WHERE id=$id ";
  $qry="SELECT * FROM cw_entity $condition";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) { 
    $ret[]=$arr;
  }

  return $ret;
  
}

// ---- putEntity(ent:entity):int ----------------------------------------------

function putEntity($ent) {
  global $db;

  $type=$ent["type"];
  $key=$ent["key"];
  if ($ent["id"]!="") {
    $id=$ent["id"];
    $oldentity=getEntity($id);
    if (!isset($oldentity[0])) $qry="INSERT INTO cw_entity (`id`,`type`,`key`) VALUES ($id, $type, $key)";
    else $qry="UPDATE cw_entity SET `type`=$type, `key`=$key WHERE id=$id";
  } else 
    $qry="INSERT INTO cw_entity (`type`,`key`) VALUES ($type, $key)";

  $res=$db->Execute($qry);
  if ($res===false) $ret=0; 
  else if ($ent["id"]!="") $ret=$ent["id"];
    else $ret=$db->Insert_ID();

  sendCommand("reload");

  return $ret;
}

// ---- delEntity(id:int):int --------------------------------------------------

function delEntity($id) {
  global $db;
  
  $qry="DELETE FROM cw_entity WHERE id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) $ret=0; else $ret=1;
  return $ret;
}

// ---- getEntityName(id:int):string ----------------------------------------------
//private
function getEntityName($entity_id) {
  $entity=getEntity($entity_id);
  $entityType=$entity[0]["type"];
  switch ($entityType) {
    case SIP_CLIENT:
    case IAX_CLIENT:
      $entityArray=getClient($entity_id,0);
      $entityName=$entityArray[0]["peer"]["name"];
    break;
    case SIP_PROVIDER:
    case ISDN_PROVIDER:
      $entityArray=getResource($entity_id);
      $entityName=$entityArray[0]["peer"]["name"];
    break;
    case IAX_DEPARTMENT:
      $entityArray=getDepartment($entity_id);
      $entityName=$entityArray[0]["name"];
    break;
    case PHONENUMBER:
      $entityArray=getPhoneNumber($entity_id);;
      $entityName=$entityArray[0]["name"];
    break;
  }
  return $entityName;
}
//******************************************************************************
//******************               CLIENT                   ********************
//******************************************************************************

// ---- getClient(id:int, prot:int):client[] -----------------------------------

function getClient($id,$prot=0) {
  global $db;

  $ext=getEntity($id);
  if (is_array($ext)) {
    foreach($ext as $v) {
      if ((($v["type"]==IAX_CLIENT or $v["type"]==SIP_CLIENT) AND $prot==0) OR ($v["type"]==$prot)) {
        unset($peer);
        unset($extension);
        
        //retrieve the peer informations
        if ($v["type"]==IAX_CLIENT) $peer=getPeer($v["key"],IAX_PROTOCOL);
        else if ($v["type"]==SIP_CLIENT) $peer=getPeer($v["key"],SIP_PROTOCOL);
        else return false;
        //errArr($peer[0]);
        $v["peer"]=$peer[0];
        
        //retrieve the extension informazions
        $qry="SELECT e.*, c.type as type FROM cw_entity_extensions c LEFT JOIN extensions_table e ON c.extension_id=e.id WHERE entity_id=".$v["id"];
        $res=$db->Execute($qry);
        while ($arr=$res->FetchRow()) {
          $extension[]=$arr;
        }
        $v["exten"]=$extension;
        
        //retrieve the client credentials
        $qry="SELECT * FROM cw_client WHERE id=".$v["id"];
        $res=$db->Execute($qry);
        $db->SetFetchMode(ADODB_FETCH_ASSOC);
        while ($arr=$res->FetchRow()) {
          foreach($arr as $field=>$value) $v[$field]=$value;
        }
  
        //retrieve the client groups
        $qry="SELECT * FROM cw_group_entity  WHERE entity_id=".$v["id"];
        $res=$db->Execute($qry);
        $db->SetFetchMode(ADODB_FETCH_ASSOC);
        while ($arr=$res->FetchRow()) {
          $v["groups"][]=$arr["group_id"];
        }

        //retrieve the voicemail
        $voicemail=getVoiceMail($v["peer"]["name"]);
        $v["voicemail"]=$voicemail[0];

        errArr($v);
        
        $ret[]=$v;
      }
    }
  }
  return $ret;
}

// ---- putClient(client:Client):int -----------------------------------

function putClient($client) {
  global $db,$realm;
  $entity=array();
  
  //go to the alterClient function
  if (isset($client["id"]) and $client["id"]!="") {
    delClient($client["id"],false);
    $entity["id"]=$client["id"];
  }

  $ret=1;
  if ($client["type"]==IAX_CLIENT) $protocol=IAX_PROTOCOL; 
  else $protocol=SIP_PROTOCOL; //default choice
  
  $client["peer"]["protocol"]=$protocol;
  
  //create a new peer
  $client["peer"]["secret"]=$client["password"]; //the password isn't crypted
  $client["peer"]["md5secret"]=""; //the password isn't crypted
  $client["peer"]["callerid"]=$client["name"]." ".$client["surname"]." <".$client["peer"]["name"].">";
  $client["peer"]["username"]=$client["username"];
  $client["peer"]["protocol"]=$protocol;
  if ($client["host"]=="dynamic" and $client["type"]==IAX_CLIENT) $client["peer"]["defaultip"]=""; //using iax, you can't have a dynamic host with a default ip, by design 

  $peer_id=putPeer($client["peer"]);
  if (is_object($peer_id) or $peer_id==0) return 0;
  
  //create a new entity
  $entity["type"]=$client["type"];
  $entity["key"]=$peer_id;
  $entity_id=putEntity($entity);
  if (is_object($entity_id) or $entity_id==0) return 0;
  
  //insert the client credentials
  $qry="INSERT INTO cw_client (id,name,surname,email,username,password) ";
  $qry.="VALUES ($entity_id,\"{$client['name']}\",\"{$client['surname']}\",\"{$client['email']}\",\"{$client['username']}\",\"{$client['password']}\")";
  $res=$db->Execute($qry);
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  //insert the extensions
  $res=putEntityToAsterisk($entity_id, $client["exten"], $client["groups"], $client["peer"]["name"]);
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
  
  //return value
  if ($ret==1) $ret=$entity_id; else $ret=0;

  //insert a new user for the web administration
  if ($ret>0) putUser(array("type"=>USER_STANDARD, "entity_id"=>$entity_id, "lang"=>$client["peer"]["language"]));

  //reload the extensions
  sendCommand("reload");

  return $ret;
}

// ---- delClient(id:int):int --------------------------------------------------

function delClient($entity_id, $reload=true) {
  global $db;

  $entityArray=getEntity($entity_id);
  $entity=$entityArray[0];

  //cancello il peer da sip_buddies o iax_buddies
  if ($entity["type"]==SIP_CLIENT) $protocol=SIP_PROTOCOL;
  elseif ($entity["type"]==IAX_CLIENT) $protocol=IAX_PROTOCOL;
  else return 0;

  //remove the client from the asterisk tables
  $ret=delEntityFomAsterisk($entity_id);

  //remove the peer data structure
  $del_result=delPeer($entity["key"],$protocol);
  if (is_object($del_result) or $del_result==0) return 0;

  //remove the client from the auxiliary table
  $qry="DELETE FROM cw_client WHERE id=".$entity_id;
  $db->Execute($qry);

  //remove the user from the auxiliary table
  $qry="DELETE FROM cw_user WHERE entity_id=".$entity_id;
  $db->Execute($qry);

  //reload the extensions
  if ($reload==true) sendCommand("reload");
  
  return $ret;
}

//******************************************************************************
//******************               DEPARTMENT               ********************
//******************************************************************************

// ---- getDepartment(id:int):department[] -----------------------------------

function getDepartment($id) {
  global $db;

  $ext=getEntity($id);
  if (is_array($ext))
  foreach($ext as $v) {
    if ($v["type"]==IAX_DEPARTMENT) {
      unset($peer);
      unset($extension);
      
      //retrieve the peer informations
      $peer=getPeer($v["key"],IAX_PROTOCOL);
      $v["peer"]=$peer[0];
      
      //retrieve the extension informazions
      $qry="SELECT e.*, c.type as type FROM cw_entity_extensions c LEFT JOIN extensions_table e ON c.extension_id=e.id WHERE entity_id=".$v["id"];
      $res=$db->Execute($qry);
      while ($arr=$res->FetchRow()) {
        $extension[]=$arr;
      }
      $v["exten"]=$extension;
      
      //retrieve the client credentials
      $qry="SELECT * FROM cw_department WHERE id=".$v["id"];
      $res=$db->Execute($qry);
      $db->SetFetchMode(ADODB_FETCH_ASSOC);
      while ($arr=$res->FetchRow()) {
        foreach($arr as $field=>$value) $v[$field]=$value;
      }
      
      //retrieve the client groups
      $qry="SELECT * FROM cw_group_entity  WHERE entity_id=".$v["id"];
      $res=$db->Execute($qry);
      $db->SetFetchMode(ADODB_FETCH_ASSOC);
      while ($arr=$res->FetchRow()) {
        $v["groups"][]=$arr["group_id"];
      }

      $ret[]=$v;
    }
  }
  return $ret;
}

// ---- putDepartment(dep:Department):int -----------------------------------

function putDepartment($dep) {
  global $db,$sandBox,$inkeyScript,$keyName;
  $entity=array();
  
  //go to the alterDepartment function
  if (isset($dep["id"]) and $dep["id"]!="") {
    delDepartment($dep["id"]);
    $entity["id"]=$dep["id"];
    //return alterDepartment($dep);
  }
  
  $ret=1;
  $entityType=IAX_DEPARTMENT;
  
  //create a new peer
  $dep["peer"]["callerid"]=$dep["name"];
  //$dep["peer"]["username"]="";
  $dep["peer"]["secret"]="";
  $dep["peer"]["auth"]="rsa";
  $dep["peer"]["inkeys"]=$dep["name"];
  $dep["peer"]["outkey"]=$keyName;
  $dep["peer"]["protocol"]=IAX_PROTOCOL;
  $peer_id=putPeer($dep["peer"]);
  if (is_object($peer_id) or $peer_id==0) return 0;
  
  //create a new entity
  $entity["type"]=$entityType;
  $entity["key"]=$peer_id;
  $entity_id=putEntity($entity);
  if (is_object($entity_id) or $entity_id==0) return 0;
  
  //insert the client credentials
  $qry="INSERT INTO cw_department (id,name,shortcut,inkey) ";
  $qry.="VALUES ($entity_id,\"{$dep['name']}\",\"{$dep['shortcut']}\",\"{$dep['inkey']}\")";
  $res=$db->Execute($qry);
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  //insert the extensions
  $res=putEntityToAsterisk($entity_id, $dep["exten"], $dep["groups"], $dep["peer"]["name"]);
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  //return value
  if ($ret==1) $ret=$entity_id; else $ret=0;

  //create the inkey file in the sandbox
  $inkeyFilename=$dep["name"];
  file_put_contents ( $sandBox.$inkeyFilename.".pub", $dep["inkey"] );

  //reload the extensions
  exec("sudo $inkeyScript \"".$inkeyFilename."\"",$output,$retScript);
  error_log("sudo $inkeyScript \"".$inkeyFilename."\"");
  errArr($output);

  //reload the extensions
  sendCommand("init keys");
  sendCommand("reload");

  return $ret;
}

// ---- delDepartment(id:int):int --------------------------------------------------

function delDepartment($entity_id) {
  global $db;

  $entityArray=getEntity($entity_id);
  $entity=$entityArray[0];

  //remove the client from the asterisk tables
  $ret=delEntityFomAsterisk($entity_id);

  //cancello il peer da sip_buddies o iax_buddies
  $del_result=delPeer($entity["key"],IAX_PROTOCOL);
  if (is_object($del_result) or $del_result==0) return 0;

  //cancello il client
  $qry="DELETE FROM cw_department WHERE id=".$entity_id;
  $db->Execute($qry);
  
/*
  //recupero le estensioni legate a questa entity e le cancello
  $qry="SELECT * FROM cw_entity_extensions WHERE entity_id=$entity_id";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) {
    $db->Execute("DELETE FROM extensions_table WHERE id=".$arr["extension_id"]);
  }        
  $db->Execute("DELETE FROM cw_entity_extensions WHERE entity_id=$entity_id");
  $db->Execute("DELETE FROM cw_group_entity WHERE entity_id=$entity_id");
  
  $ret=delEntity($entity_id);
*/
  return $ret;
}

//******************************************************************************
//******************               RESOURCE                 ********************
//******************************************************************************

// ---- getResource(id:int, type:int):Resource[] -------------------------------

function getResource($id,$prot=0) {
  global $db;
  $ext=getEntity($id);

  if (is_array($ext))
  foreach($ext as $v) {
    if ((($v["type"]==ISDN_PROVIDER or $v["type"]==SIP_PROVIDER) AND $prot=="") OR ($v["type"]==$prot)) {
      unset($peer);
      unset($extension);
      
      //retrieve the peer informations
      if ($v["type"]==SIP_PROVIDER) $peer=getPeer($v["key"],SIP_PROTOCOL);
      else if ($v["type"]==ISDN_PROVIDER) $peer=array(0=>null);
      else return false;
      $v["peer"]=$peer[0];
      
      //retrieve the extension informazions
      $qry="SELECT e.*, c.type as type FROM cw_entity_extensions c LEFT JOIN extensions_table e ON c.extension_id=e.id WHERE entity_id=".$v["id"];
      $res=$db->Execute($qry);
      while ($arr=$res->FetchRow()) {
        $extension[]=$arr;
      }
      $v["exten"]=$extension;
      
      //retrieve the provider credentials
      $qry="SELECT * FROM cw_resource WHERE id=".$v["id"];
      $res=$db->Execute($qry);
      $db->SetFetchMode(ADODB_FETCH_ASSOC);
      while ($arr=$res->FetchRow()) {
        foreach($arr as $field=>$value) $v[$field]=$value;
      }

      //retrieve the client groups
      $qry="SELECT * FROM cw_group_entity  WHERE entity_id=".$v["id"];
      $res=$db->Execute($qry);
      $db->SetFetchMode(ADODB_FETCH_ASSOC);
      while ($arr=$res->FetchRow()) {
        $v["groups"][]=$arr["group_id"];
      }
      
      $ret[]=$v;
    } 
  }
  return $ret;
}

// ---- putResource(res:Resources):int -----------------------------------

function putResource($res) {
  global $db;

  $entity=array();
  //modify? delete and create a new entry
  if (isset($res["id"]) and $res["id"]!="") {
    error_log("Cancellazione vecchio record: ".$res["id"]);
    delResource($res["id"]);
    $entity["id"]=$res["id"];
  }
  $ret=1;

  errArr($res);
  //create a new peer
  if ($res["type"]==SIP_PROVIDER) {
    //$res["peer"]["secret"]=$res["password"]; //the password isn't crypted
    //$res["peer"]["md5secret"]="NULL"; //the password isn't crypted
    //$res["peer"]["username"]=$res["username"];
    //$res["peer"]["port"]=$res["peer"]["ports"];
    $res["peer"]["callerid"]=$res["name"];
    $res["peer"]["fromuser"]=$res["peer"]["username"];
    $res["peer"]["protocol"]=SIP_PROTOCOL;
    $peer_id=putPeer($res["peer"]);
    if (is_object($peer_id) or $peer_id==0) return 0;
  } else if ($res["type"]==ISDN_PROVIDER) {
    $peer_id=0;
    $qry="INSERT INTO provider (providername,dialstr,status) VALUES (\"{$res['name']}\",\"mISDN/g:extern1/00%s|30\",0)";
    $r=$db->Execute($qry);
    $peer_id=$db->Insert_ID();
  } else return 0;
    
  //create a new entity
  $entity["type"]=$res["type"];
  $entity["key"]=$peer_id;
  $entity_id=putEntity($entity);
  if (is_object($entity_id) or $entity_id==0) return 0;
  
  //insert the provider credentials
  $qry="INSERT INTO cw_resource (id,name,opcode) ";
  $qry.="VALUES ($entity_id,\"{$res['name']}\",\"{$res['opcode']}\")";
  $r=$db->Execute($qry);
  if ($r===false) $ret=$ret and 0; else $ret=$ret and 1;

  //insert the extensions
  $res=putEntityToAsterisk($entity_id, $res["exten"], $res["groups"], $res["peer"]["name"]);  
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  //return value
  if ($ret==1) $ret=$entity_id; else $ret=0;

  //rewrite the SIP.conf 
  writeSIP(false);
  
  //reload the extensions
  sendCommand("reload");

  return $ret;
}

// ---- delResource(id:int):int --------------------------------------------------

function delResource($entity_id) {
  global $db;

  $entityArray=getEntity($entity_id);
  $entity=$entityArray[0];
  //cancello il peer da sip_buddies o provider
  if ($entity["type"]==ISDN_PROVIDER) {
    $qry="DELETE FROM provider WHERE providerid=".$entity["key"];
    $res=$db->Execute($qry);
    if ($res===false) return 0;
  } elseif ($entity["type"]==SIP_PROVIDER) {
    //remove the resource from the asterisk tables
    $ret=delEntityFomAsterisk($entity_id);
    //remove the peer
    $del_result=delPeer($entity["key"],SIP_PROTOCOL);
    //if (is_object($del_result) or $del_result==0) return 0;
  } else return 0;

  //remove the entry from the resource table
  $qry="DELETE FROM cw_resource WHERE id=".$entity_id;
  $db->Execute($qry);
  return $ret;
}

// ---- alterResource(res:Resource):int ----------------------------------------

function alterResource($res) {
  global $db;
  $ret=1;

  //read the old resource information
  $r=getResource($res["id"]);
  $oldResource=$r[0];
  if (!isset($res["type"])) $res["type"]=$oldResource["type"];

  //modify the peer data
  if ($res["type"]==SIP_PROVIDER) {
    if ($res["type"]==$oldResource["type"]) {
      $res["peer"]["id"]=$oldResource["peer"]["id"];
      $res["peer"]["callerid"]=$res["name"];
      $res["peer"]["protocol"]=SIP_PROTOCOL;
      $peer_result=alterPeer($res["peer"]);
      if (is_object($peer_result) or $peer_result==0) return 0;
    } else {
      $qry="DELETE FROM provider WHERE providerid=".$res["id"];
      $r=$db->Execute($qry);
      if ($r===false) return 0;
      $res["peer"]["callerid"]=$res["name"];
      $res["peer"]["protocol"]=SIP_PROTOCOL;
      $peer_id=putPeer($res["peer"]);
      if (is_object($peer_id) or $peer_id==0) return new soap_fault('Client','','Peer creation error');
      
      //update entity type
      $qry="UPDATE cw_entity SET `type`=".SIP_PROVIDER.", `key`=".$peer_id." WHERE `id`=".$res["id"];
      $r=$db->Execute($qry);
      if ($r===false) return new soap_fault('Client','','Cant do entity changes');
    }
  } else if ($res["type"]==ISDN_PROVIDER) {
    if ($res["type"]==$oldResource["type"]) {
      $qry="UPDATE provider SET providername=\"{$res['name']}\", dialstr=\"mISDN/g:extern1/00%s|30\",status=0 WHERE providerid=".$res["id"];
      $r=$db->Execute($qry);
      if ($r===false) return 0;
    } else {
      $r=delPeer($oldResource["peer"]["id"]);
      if ($r===false) return 0;
      $qry="INSERT INTO provider (providername,dialstr,status) VALUES (\"{$res['name']}\",\"mISDN/g:extern1/00%s|30\",0)";
      $r=$db->Execute($qry);
      $peer_id=$db->Insert_ID();

      //update entity type
      $qry="UPDATE cw_entity SET `type`=".ISDN_PROVIDER.", `key`=".$peer_id." WHERE `id`=".$res["id"];
      $r=$db->Execute($qry);
      if ($r===false) return new soap_fault('Client','','Cant do entity changes');
    }
  } else return 0;

  //get the entity id
  $entity_id=$oldResource["id"];
  
  //update the resource credentials
  $qry="UPDATE cw_resource SET `name`=\"{$res['name']}\", `opcode`=\"{$res['opcode']}\"  WHERE `id`=$entity_id";
  $r=$db->Execute($qry);
  if ($r===false) $ret=$ret and 0; else $ret=$ret and 1;

  //recupero le estensioni legate a questa entity e le cancello
  $qry="SELECT * FROM cw_entity_extensions WHERE `entity_id`=$entity_id";
  $r=$db->Execute($qry);
  while ($arr=$r->FetchRow()) {
    $db->Execute("DELETE FROM extensions_table WHERE `id`=".$arr["extension_id"]);
  }        
  $db->Execute("DELETE FROM cw_entity_extensions WHERE `entity_id`=$entity_id");

  //insert the extensions
  $res=putEntityToAsterisk($entity_id, $res["exten"], $res["groups"], $res["peer"]["name"]);  //$res[peer] serve a qualcosa??
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  return $ret;
}

//******************************************************************************
//******************               PHONENUMBERS                  ***************
//******************************************************************************

// ---- getPhoneNumber(id:int):phonenumber[] -----------------------------------

function getPhoneNumber($id) {
  global $db;

  $ext=getEntity($id);
  if (is_array($ext))
  foreach($ext as $v) {
    if ($v["type"]==PHONENUMBER) {
      unset($peer);
      unset($extension);
      
      //retrieve the extension informazions
      $qry="SELECT e.*, c.type as type FROM cw_entity_extensions c LEFT JOIN extensions_table e ON c.extension_id=e.id WHERE entity_id=".$v["id"];
      $res=$db->Execute($qry);
      while ($arr=$res->FetchRow()) {
        $extension[]=$arr;
      }
      $v["exten"]=$extension;
      
      //retrieve the phnenumber information
      $qry="SELECT * FROM cw_number WHERE id=".$v["id"];
      $res=$db->Execute($qry);
      $db->SetFetchMode(ADODB_FETCH_ASSOC);
      while ($arr=$res->FetchRow()) {
        foreach($arr as $field=>$value) $v[$field]=$value;
      }

      //retrieve the client groups
      $qry="SELECT * FROM cw_group_entity  WHERE entity_id=".$v["id"];
      $res=$db->Execute($qry);
      $db->SetFetchMode(ADODB_FETCH_ASSOC);
      while ($arr=$res->FetchRow()) {
        $v["groups"][]=$arr["group_id"];
      }
      
      $ret[]=$v;
    }
  }
  
  return $ret;
}

// ---- putPhoneNumber(number:PhoneNumber):int -----------------------------------

function putPhoneNumber($number) {
  global $db;

  $ret=1;
  $entity=array();
  
  //go to the alterPhoneNumber function
  if (isset($number["id"]) and $number["id"]!="") {
    delPhoneNumber($number["id"]);
    $entity["id"]=$number["id"];
    //return alterPhoneNumber($number);
  }

  //create a new entity
  $entity["type"]=PHONENUMBER;
  $entity["key"] =0;  //key is zero. The NUMBER entity hasn't a reference table, so no key has to be written
  $entity_id=putEntity($entity);
  if (is_object($entity_id) or $entity_id==0) return 0;
  
  //insert the phonenumber credentials
  $qry="INSERT INTO cw_number (id,name) ";
  $qry.="VALUES ($entity_id,\"{$number['name']}\")";
  $res=$db->Execute($qry);
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
  
  //insert the extensions
  $res=putEntityToAsterisk($entity_id, $number["exten"], $number["groups"], $number["name"]);
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
  
/*  
  //insert the phonenumber in the ast_config
  $context=$number["name"];
  $res=putAstConfig("extensions.conf", $context, "switch", "Realtime/@extensions");
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  //create the extension
  foreach ($number["exten"] as $v) {
    $e=generateExtension($context,$v["exten"],$v["priority"],$v["type"]);
    $extension_id=putExtension($e);
    $extension_type=$e["type"];
    if ($extension_id>0 and !is_object($extension_id)) {
      $qry="INSERT INTO cw_entity_extensions (entity_id, extension_id, type) VALUES ($entity_id, $extension_id, $extension_type)";
      $res=$db->Execute($qry);
      if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
    }
  }
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  //include the phonenumber inside the selected groups
  if (is_array($number["groups"])) {
    foreach ($number["groups"] as $g) {
      $groupArr=getGroup($g);
      $includeContext=$groupArr[0]["name"];
      $res=putAstConfig("extensions.conf", $includeContext, "include", $context);
      if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
    }  
  
    //add this entity to the choosed groups
    $res=entityToGroups($entity_id,$number["groups"]);
    if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
  }
*/
  
  //return value
  if ($ret==1) $ret=$entity_id; else $ret=0;

  //reload the extensions
  sendCommand("reload");

  return $ret;
}

// ---- delPhoneNumber(id:int):int --------------------------------------------------

function delPhoneNumber($entity_id) {
  global $db;

  $entityArray=getPhoneNumber($entity_id);
  $phoneNumberName=$entityArray[0]["name"];

  //remove the entity from the asterisk tables
  $ret=delEntityFomAsterisk($entity_id);

  //cancello il client
  $qry="DELETE FROM cw_number WHERE id=".$entity_id;
  $db->Execute($qry);
  
/*  
  //recupero le estensioni legate a questa entity e le cancello
  $qry="SELECT * FROM cw_entity_extensions WHERE entity_id=$entity_id";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) {
    $db->Execute("DELETE FROM extensions_table WHERE id=".$arr["extension_id"]);
  }        
  $db->Execute("DELETE FROM cw_entity_extensions WHERE entity_id=$entity_id");
  $db->Execute("DELETE FROM cw_group_entity WHERE entity_id=$entity_id");
  
  $res=delAstConfig("extensions.conf","%","include",$phoneNumberName);
  $res=delAstConfig("extensions.conf",$phoneNumberName,"switch");
  
  $ret=delEntity($entity_id);
*/
  return $ret;
}

//******************************************************************************
//******************               GROUP                    ********************
//******************************************************************************

// ---- getGroup(id:int,type:int):Group[] -----------------------------------------------

function getGroup($id,$type=0) {
  global $db;
  $count=0;
  if ($type!=0) $condition="WHERE type=$type ";
  if ($id!="") $condition="WHERE id=$id ";
  $qry="SELECT * FROM cw_group $condition ORDER BY type, name";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) { 
    $group_id=$arr["id"];

    //retrieve the entity array
    unset($entity);
    $qry="SELECT entity_id FROM cw_group_entity WHERE group_id=$group_id";
    $res2=$db->Execute($qry);
    while ($arr2=$res2->FetchRow()) $entity[]=$arr2["entity_id"];
    $arr["entity"]=$entity;

    //retrieve the group array
    unset($right);
    $qry="SELECT right_id FROM cw_right_group WHERE group_id=$group_id";
    $res3=$db->Execute($qry);
    while ($arr3=$res3->FetchRow()) $right[]=$arr3["right_id"];
    $arr["right"]=$right;

    $ret[]=$arr;
  }
  return $ret;
}

// ---- putGroup(group:Group):int ----------------------------------------------

function putGroup($group) {
  global $db;

  //go to the alterGroup function
  if (isset($group["id"]) and $group["id"]!="") {
    $group_id=$group["id"];

    //remove the group
    delGroup($group_id);
    $id_field="`id`,";
    $id_value=$group_id.", ";
    //return alterGroup($group);
  }


  $ret=1;
  $name=$group["name"];
  $type=$group["type"];
  $qry="INSERT INTO cw_group ($id_field `name`,`type`) VALUES ($id_value '$name', $type)";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Group creation error, mysql INSERT command failed'); 
  else if (!isset($group_id)) $group_id=$db->Insert_ID();

  //insert the group into Asterisk
  if (is_array($group["entity"]))
  foreach ($group["entity"] as $e) {
    $entityName=getEntityName($e);
    $res=putAstConfig("extensions.conf", $name, "include", $entityName);
    if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

    //add this entity to the group
    $res=entityToGroups($e,array($group_id));
    if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
  }

  //insert the groups into the selected rights
  if (is_array($group["right"]))
  foreach ($group["right"] as $r) {
    $res=groupToRight($r, array($group_id));
    if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
  }

/*
  if (is_array($group["entity"])) { 
    foreach ($group["entity"] as $entity_id) {
      $qry="INSERT INTO cw_group_entity (`group_id`,`entity_id`) VALUES ($group_id, $entity_id)";
      $res=$db->Execute($qry);
      if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
    }    
  }
  //insert the group in the ast_config
  $res=putAstConfig("extensions.conf","$name","switch","Realtime/@extensions");
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
*/  
  //return value
  if ($ret>0) $ret=$group_id;

  //reload the extensions
  sendCommand("reload");
  
  return $ret;
}

// ---- delGroup(id:int):int --------------------------------------------------

function delGroup($id) {
  global $db;
  
  //retrieve the group name
  $g=getGroup($id);
  $name=$g[0]["name"];

  $qry="DELETE FROM cw_group WHERE id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Group remove error, mysql DELETE command failed');

  $qry="DELETE FROM cw_group_entity WHERE group_id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Group-entity remove error, mysql DELETE command failed');

  $qry="DELETE FROM cw_right_group WHERE group_id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Right-Group remove error, mysql DELETE command failed');
  
  //remove the group related entry in the ast_config table
  $res=delAstConfig("extensions.conf",$name);
  $res=delAstConfig("extensions.conf","%","include",$name);
  
  return 1;
}


// ---- entityToGroups(entity:int, groups:int[]):int ---------------------------
//      this function is private

function entityToGroups($entity_id,$groups) {
  global $db;
  $ret=1;
  //$qry="DELETE FROM cw_group_entity WHERE `entity_id`=$entity_id";
  //$res=$db->Execute($qry);

  if (is_array($groups)) {
    foreach ($groups as $group_id) {
      $qry="INSERT INTO cw_group_entity (`group_id`,`entity_id`) VALUES ($group_id, $entity_id)";
      $res=$db->Execute($qry);
      if ($res===false) return false;
    }    
  }

  //create the global var in the Ast_Config
  generateGlobalVar($groups);

  return true;
}

//******************************************************************************
//******************               RIGHTS                   ********************
//******************************************************************************

// ---- getRight(id:int):Right[] -----------------------------------------------

function getRight($id=0) {
  global $db;
  $count=0;
  if ($id!="") $condition="WHERE id=$id ";
  $qry="SELECT * FROM cw_right $condition ORDER BY name";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) { 
    $right_id=$arr["id"];

    unset($group);
    $qry="SELECT group_id FROM cw_right_group WHERE right_id=$right_id";
    $res2=$db->Execute($qry);
    while ($arr2=$res2->FetchRow()) $group[]=$arr2["group_id"];
    $arr["group"]=$group;

    unset($application);
    $qry="SELECT application_id FROM cw_right_application WHERE right_id=$right_id";
    $res3=$db->Execute($qry);
    while ($arr3=$res3->FetchRow()) $application[]=$arr3["application_id"];
    $arr["application"]=$application;


    $ret[]=$arr;
  }
  return $ret;
}

// ---- putRight(right:Right):int ----------------------------------------------

function putRight($right) {
  global $db;
  
  //go to the alterRight function
  if (isset($right["id"]) and $right["id"]!="") {
    $right_id=$right["id"];
    delRight($right_id);
    $id_field="`id`,";
    $id_value=$right_id.", ";
  }
  
  $ret=1;
  $name=$right["name"];
  $action=$right["action"];
  $action_option=$right["action_option"];
  $qry="INSERT INTO cw_right ($id_field `name`,`action`,`action_option`) VALUES ($id_value '$name','$action','$action_option')";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Rights creation error, mysql INSERT command failed'); 
  else if (!isset($right_id)) $right_id=$db->Insert_ID();

  //insert the groups into the right in the ast_config
  $res=groupToRight($right_id, $right["group"]);
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  //insert the application into the right in the ast_config
  $res=applicationToRight($right_id, $right["application"]);
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  //insert the action
  $res=putAstConfig("extensions.conf", $name, "switch", "Realtime/@extensions");
  putAction($name,"s",$action,$action_option,0);
  
  //return value
  if ($ret>0) $ret=$right_id;

  //reload the extensions
  sendCommand("reload");

  return $ret;
}

// ---- delRight(id:int):int --------------------------------------------------

function delRight($id) {
  global $db;
  
  //retrieve the right name
  $r=getRight($id);
  $name=$r[0]["name"];

  $qry="DELETE FROM cw_right WHERE id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Rights remove error, mysql DELETE command failed');

  $qry="DELETE FROM cw_right_group WHERE right_id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Right-Group remove error, mysql DELETE command failed');

  $qry="DELETE FROM cw_right_application WHERE right_id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Right-Application remove error, mysql DELETE command failed');
  
  //remove the action linked to this right
  $res=$db->Execute("DELETE FROM extensions_table WHERE context='".$name."' ");
  
  //remove the right related entry in the ast_config table
  $res=delAstConfig("extensions.conf",$name);
  
  return 1;
}


// ---- groupToRight(group:int, rights:int[]):int ---------------------------
//      this function is private

function groupToRight($right_id,$groups) {
  global $db;
  $ret=1;
  $rig=getRight($right_id);
  $rightName=$rig[0]["name"];

  if (is_array($groups)) 
  foreach ($groups as $group_id) {
    $qry="INSERT INTO cw_right_group (`right_id`,`group_id`) VALUES ($right_id, $group_id)";
    $res=$db->Execute($qry);
    if ($res===false) return false;
    $grp=getGroup($group_id);
    $groupName=$grp[0]["name"];
    $res=putAstConfig("extensions.conf","$rightName","include","$groupName");
    if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
  }    

  return $ret;
}

// ---- applicationToRight(right_id:int, application:int[]):int ---------------------------
//      this function is private

function applicationToRight($right_id,$application) {
  global $db;
  $ret=1;
  $rig=getRight($right_id);
  $rightName=$rig[0]["name"];

  if (is_array($application)) 
  foreach ($application as $application_id) {
    $qry="INSERT INTO cw_right_application (`right_id`,`application_id`) VALUES ($right_id, $application_id)";
    $res=$db->Execute($qry);
    if ($res===false) return false;
    $app=getApplication($application_id);
    $applicationName=$app[0]["context"];
    $res=putAstConfig("extensions.conf","$rightName","include","$applicationName");
    if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
  }    

  return $ret;
}


//******************************************************************************
//******************               QUEUE                   *********************
//******************************************************************************

// ---- getQueue(id:int):Queue[] -----------------------------------------------

function getQueue($id) {
  global $db;
  $count=0;
  if ($id!="") $condition="WHERE id=$id ";
  $qry="SELECT * FROM cw_queue $condition ORDER BY name";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) { 
    $queue_id=$arr["id"];
    $name=$arr["name"];

    //extract the attributes from the ast_config
    $qry="SELECT * FROM ast_config WHERE filename='queues.conf' AND category='$name'";
    $res2=$db->Execute($qry);
    while ($arr2=$res2->FetchRow()) 
      if ($arr["var_name"]!="member") $arr[$arr2["var_name"]]=$arr2["var_val"];

    //extract the member from the queue_member table
    unset($member);
    $qry="SELECT member_id FROM cw_queue_member WHERE queue_id=$queue_id";
    $res2=$db->Execute($qry);
    while ($arr2=$res2->FetchRow()) $member[]=$arr2["member_id"];
    $arr["member"]=$member;
    $ret[]=$arr;
  }
  return $ret;
}

// ---- putQueue(queue:Queue):int ----------------------------------------------

function putQueue($queue) {
  global $db;
  
  //go to the alterQueue function
  if (isset($queue["id"]) and $queue["id"]!="") {
    $queue_id=$queue["id"];
    //remove the queue
    delQueue($queue_id);
    $entity["id"]=$queue_id;
  }

  //create a new entity
  $entity["type"]=QUEUE;
  $entity["key"] =0;  //key is zero. The NUMBER entity hasn't a reference table, so no key has to be written
  $entity_id=putEntity($entity);
  if (is_object($entity_id) or $entity_id==0) return 0;
  
  $ret=1;
  $name=$queue["name"];
  $qry = "INSERT INTO cw_queue (`id`,`name`) VALUES ($entity_id,'$name')";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Queue creation error, mysql INSERT command failed'); 
  else if ($queue_id=="") $queue_id=$db->Insert_ID();

  $queue["timeout"]="15";
  
  //insert the queue propriety in the ast_config table  
  foreach ($queue as $k=>$v) {
    if ($k!="id" and $k!="member" and $k!="name") {
      $res=putAstConfig("queues.conf", "$name", $k, $v);
    }
  }  
  
  //insert the members into the queue in the ast_config
  $res=memberToQueue($queue_id, $queue["member"]);
  if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;

  //return value
  if ($ret>0) $ret=$queue_id;

  //reload the extensions
  sendCommand("reload");

  return $ret;
}

// ---- delQueue(id:int):int --------------------------------------------------

function delQueue($id) {
  global $db;
  
  //retrieve the queue name
  $q=getQueue($id);
  $name=$q[0]["name"];

  //remove the entity from the asterisk tables
  $ret=delEntityFomAsterisk($id);

  //delete entry from the support table 
  $qry="DELETE FROM cw_queue WHERE id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Queue remove error, mysql DELETE command failed');

  //delete entry from the support table
  $qry="DELETE FROM cw_queue_member WHERE queue_id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Queue-member remove error, mysql DELETE command failed');

  //remove the queue related entry in the ast_config table
  $res=delAstConfig("queues.conf",$name);
  
  return 1;
}

// ---- memberToQueue(queue:int, member:int[]):int ---------------------------
//      this function is private

function memberToQueue($queue_id,$member) {
  global $db;
  $ret=1;
  $queue=getQueue($queue_id);
  $queueName=$queue[0]["name"];
  $qry="DELETE FROM cw_queue_member WHERE `queue_id`=$queue_id";
  $res=$db->Execute($qry);
  
  //$qry="DELETE FROM ast_config WHERE `filename`='queues.conf' AND `category`='$queueName' and var_name='member'";
  //$res=$db->Execute($qry);
  $res=delAstConfig("queues.conf",$queueName,"member");


  if (is_array($member))
  foreach ($member as $member_id) {
    $qry="INSERT INTO cw_queue_member (`queue_id`,`member_id`) VALUES ($queue_id, $member_id)";
    $res=$db->Execute($qry);
    if ($res===false) return false;
    $m=getClient($member_id);
    $memberName=$m[0]["peer"]["name"];
    $memberProtocol=$m[0]["peer"]["protocol"];
    if ($memberProtocol==SIP_PROTOCOL) $res=putAstConfig("queues.conf","$queueName","member","SIP/".$memberName);
    if ($memberProtocol==IAX_PROTOCOL) $res=putAstConfig("queues.conf","$queueName","member","IAX/".$memberName);
    if ($res===false) $ret=$ret and 0; else $ret=$ret and 1;
  }    
  return $ret;
}


//******************************************************************************
//******************               VOICE MAIL              *********************
//******************************************************************************

// ---- getVoiceMail(id:int):VoiceMail[] ---------------------------------------
function getVoiceMail($id) {
  global $db;
  $count=0;
  if ($id!="") $condition="WHERE mailbox=$id ";
  $qry="SELECT * FROM voicemail_users $condition ORDER BY mailbox";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) { 
    $arr["id"]=$arr["uniqueid"];
    $ret[]=$arr;
  }
  return $ret;
}

// ---- putVoiceMail(voicemail:VoiceMail):int ---------------------------------------
function putVoiceMail($voicemail) {
  global $db;
  $id="";
  $id_value="";
  
  //if already exists, delete it
  if (isset($voicemail["mailbox"]) and $voicemail["mailbox"]!="") {
    delVoiceMail($voicemail["mailbox"],false);
  } else return 0; //no mail box is defined
  
  //insert the mailbox
  $qry="INSERT INTO voicemail_users (context, mailbox, password, fullname, email, pager, attach, saycid, hidefromdir) ";
  $qry.="VALUES ('default', \"{$voicemail['mailbox']}\",\"{$voicemail['password']}\",\"{$voicemail['fullname']}\",\"{$voicemail['email']}\",\"{$voicemail['pager']}\",\"{$voicemail['attach']}\",\"{$voicemail['saycid']}\",\"{$voicemail['hidefromdir']}\")";
  $res=$db->Execute($qry);
  
  if ($res===false) $ret=0; 
  else return $voicemail["mailbox"]; 
}
  
// ---- delVoiceMail(id:int):int ---------------------------------------
function delVoiceMail($mailbox) {
  global $db;
  $qry="DELETE FROM voicemail_users WHERE mailbox=$mailbox";
  $res=$db->Execute($qry);
  if ($res===false) $ret=0; 
  else return 1;
}


//******************************************************************************
//******************               ISDN CARD               *********************
//******************************************************************************

// ---- getCard(id:int):Card[] -----------------------------------------------

function getCard($id) {
  global $db;
  $count=0;
  if ($id!="") $condition="WHERE id=$id ";
  $qry="SELECT * FROM cw_isdn_card $condition";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) $ret[]=$arr;
  return $ret;
}


// ---- putCard(id:int):int -----------------------------------------------
// you can add an isdn card by simply passing the id of the card type.

function putCard($id) {
  global $db;

  //read how many ports are already installed
  $qry="SELECT * FROM cw_isdn_port";
  $res=$db->Execute($qry);
  $installedPort=$res->RecordCount();

  //read how many ports has the choosed card
  $qry="SELECT * FROM cw_isdn_card WHERE id=$id";
  $res=$db->Execute($qry);
  $arr=$res->FetchRow();
  $ports=$arr["ports"];
  
  //read the id of the previous installed card 
  $qry="SELECT MAX(card_id) as lastid FROM cw_isdn_port";
  $res=$db->Execute($qry);
  $arr=$res->FetchRow();
  $card_id=$arr["lastid"];
  if ($card_id!="NULL") $card_id++; else $card_id=1;
  
  $res=true;
  for ($i=1; $i<=$ports; $i++) {
    $qry="INSERT INTO cw_isdn_port (port,layermask,protocol,card,card_id) VALUES ($i,'0xf','0x2',$id,$card_id)";
    $res&=$db->Execute($qry);
  }

  //write to AstConfig or File
  writeMIsdn(false);

  //update the misdn-init.conf
  error_log("installed port: $installedPort");
  if ($installedPort>0) writeModprobe(true);
  else writeModprobe(false);
  
  if ($res===true) $res=$card_id;
  return $res;
}

// ---- delCard(id:int):int -----------------------------------------------

function delCard($id) {
  global $db;
  $res=true;
  $qry="DELETE FROM cw_isdn_port WHERE card_id=$id";
  $res&=$db->Execute($qry);
  writeModprobe(true);
  return 1;
}

//******************************************************************************
//******************               ISDN PORT               *********************
//******************************************************************************

// ---- getPort(id:int):Port[] -----------------------------------------------

function getPort($id) {
  global $db;
  $count=0;
  if ($id!="") $condition="WHERE id=$id ";
  $qry="SELECT * FROM cw_isdn_port $condition ORDER BY card_id, port";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) {

    //check if available
    $res2=$db->Execute("SELECT * FROM cw_isdn_portgroup WHERE port=".$arr["id"]);
    if ($res2->RecordCount()>0) $arr["available"]=0; else $arr["available"]=1;

    $ret[]=$arr;
  }
  return $ret;
}

// ---- updatePort(ports:Port[]):int -------------------------------------------

function updatePort($ports) {
  global $db;
  $res=true;
  foreach ($ports as $p) {
    $id=$p["id"];
    $layermask=$p["layermask"];
    $protocol=$p["protocol"];
    $qry="UPDATE cw_isdn_port SET layermask='$layermask', protocol='$protocol' WHERE id=$id";
    $res&=$db->Execute($qry);
  }
  writeModprobe(true);
  return $res;
}

// ---- writeModprobe():int ----------------------------------------------
//private

function writeModprobe($stop=false) {
  global $db,$modprobe,$misdn_conf,$misdn_sh,$safe_asterisk;
  $txt="";
  $ports=getPort(0);
  $card_old=0;
  $count=1;
  
  foreach ($ports as $p) {
    $card_id=$p["card_id"];
    $card=$p["card"];
    $port=$p["port"];
    $layermask=$p["layermask"]; 
    $protocol=$p["protocol"];
    if ($card_id!=$card_old) {
      if ($card==1) $driver="hfcpci";
      if ($card==2) $driver="0x4";
      if ($card==3) $driver="0x8";
      $cardLine.="card=".$card_id.",".$driver."\n";
    } 
    if ($layermask=="0xf") {
      if ($protocol=="0x2") $te_ptmp.=$count.","; else $te_ptp.=$count.",";
    } else {
      if ($protocol=="0x12") $nt_ptmp.=$count.","; else $nt_ptp.=$count.",";
    }
    
    $card_old=$card_id;
    $count++;

  }  //end of while
  
  $txt.=$cardLine;
  
  if ($te_ptmp!="") $txt.="te_ptmp=".substr($te_ptmp,0,-1)."\n"; 
  if ($te_ptp!="")  $txt.="te_ptp=".substr($te_ptp,0,-1)."\n";
  if ($nt_ptmp!="") $txt.="nt_ptmp=".substr($nt_ptmp,0,-1)."\n"; 
  if ($nt_ptp!="") $txt.="nt_ptp=".substr($nt_ptp,0,-1)."\n";
  
  $txt.="poll=64\n";
  $txt.="debug=0\n";
  
  $ret=file_put_contents($modprobe,$txt); 

  unset($out);
  //restart the asterisk
  if ($stop===true) {
    error_log("$stop - $count");
    error_log("sudo $safe_asterisk stop");exec("sudo $safe_asterisk stop",$out);errArr($out);//stop the asterisk
    error_log("sudo $misdn_sh stop");exec("sudo $misdn_sh stop",$out);errArr($out); //stop the asterisk driver
  }
  error_log("sudo ".$misdn_conf);exec("sudo ".$misdn_conf,$out);errArr($out); //move the misdn configuration file
  errArr($out);
  if ($count>1) {
    error_log("sudo ".$misdn_sh." start");exec("sudo ".$misdn_sh." start",$out); errArr($out);
    sleep(5);
    error_log("sudo $safe_asterisk start");exec("sudo $safe_asterisk start",$out); errArr($out); //start the asterisk    
  }      
  error_log("Completed!");
  return $ret;
}

//******************************************************************************
//******************               ISDN GROUP              *********************
//******************************************************************************

// ---- getIsdnGroup(id:int):Group[] -------------------------------------------

function getIsdnGroup($id,$onlyCustomOption=false) {
  global $db;
  $count=0;
  if ($id!="") $condition="WHERE id=$id ";
  $qry="SELECT * FROM cw_isdn_group $condition ORDER BY trunk_order";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) { 
    unset($opt);
    $group_id=$arr["id"];
    $name=$arr["name"];
    $trunk_order=$arr["trunk_order"];

    //extract the ports of the group
    unset($port);
    $qry="SELECT * FROM cw_isdn_portgroup WHERE `group`=$group_id";
    $res2=$db->Execute($qry);
    while ($arr2=$res2->FetchRow()) $port[]=$arr2["port"];
    $arr["port"]=$port;

    //extract the phonenumber of the group
    unset($number);
    unset($arrNumber);
    $qry="SELECT * FROM cw_isdn_phonenumber WHERE `group`=$group_id";
    $res2=$db->Execute($qry);
    while ($arr2=$res2->FetchRow()) {
      $number["id"]=$arr2["id"];
      $number["number"]=$arr2["number"];
      $number["fax"]=$arr2["fax"];
      $number["action"]=$arr2["action"];
      $number["action_option"]=$arr2["action_option"];
      $arrNumber[]=$number;
    }
    $arr["msns"]=$arrNumber;

    //read the specific group option
    unset($specificOpt);
    $qry="SELECT * FROM cw_isdn_option WHERE id_group='$group_id'";
    $res3=$db->Execute($qry);
    while ($arr3=$res3->FetchRow()) {
      $specificOpt[$arr3["id_option"]]=$arr3["value"];
    }
    
    //extract the general options
    unset($option);
    $qry="SELECT * FROM cw_option WHERE category='".OPTION_ISDN_GROUPS."' ORDER BY name";
    $res3=$db->Execute($qry);
    while ($arr3=$res3->FetchRow()) {
      $id_option=$arr3["id"];
      $name=$arr3["name"];
      $value=$arr3["value"];
      $default=$arr3["default"];
      $option["id"]=$id_option;
      
      if (isset($specificOpt[$id_option])) $option["value"]=$specificOpt[$id_option];
      else if ($value!="") $option["value"]=$value;
      else $option["value"]=$default;
      
      //verifico che sia stato scelto di visualizzare solo le impostazioni personalizzate oppure no
      if ((isset($specificOpt[$id_option]) and $onlyCustomOption===true) or ($onlyCustomOption===false))
        $opt[]=$option;
    }
    $arr["option"]=$opt;
    
    $ret[]=$arr;
  }
  return $ret;
}

// ---- putIsdnGroup(group:IsdnGroup):int ----------------------------------------------

function putIsdnGroup($group) {
  global $db;
  
  //go to the alterQueue function
  if (isset($group["id"]) and $group["id"]!="") {
    $group_id=$group["id"];
    error_log("id gruppo: $group_id");
    //remove the isdn group
    delIsdnGroup($group_id,false);
    $id_field="`id`,";
    $id_value=$group_id.", ";
  }
  
  $ret=1;
  $name=$group["name"];
  $trunk_order=$group["trunk_order"];
  $msns=$group["msns"];
  $ports=$group["port"];

  //insert the isdn group
  $qry = "INSERT INTO cw_isdn_group ($id_field `name`,`trunk_order`) VALUES ($id_value '$name','$trunk_order')";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Isdn Group creation error, mysql INSERT command failed'); 
  else if ($group_id=="") $group_id=$db->Insert_ID();

  //insert the ports
  if (is_array($ports))
  foreach($ports as $p) {
    $qry = "INSERT INTO cw_isdn_portgroup (`port`,`group`) VALUES ($p,$group_id)";
    $res=$db->Execute($qry);
  }

  
  //insert the numbers
  if (is_array($msns))
  foreach($msns as $n) {
    $number=$n["number"];
    $fax=$n["fax"];
    $action=$n["action"];
    $action_option=$n["action_option"];
    $qry = "INSERT INTO cw_isdn_phonenumber (`number`,`group`,`fax`,`action`,`action_option`) VALUES ('$number',$group_id,'$fax','$action','$action_option')";
    $res=$db->Execute($qry);
  }

  //insert the options
  if (is_array($group["option"]))
  foreach($group["option"] as $o) {
    $option_id=$o["id"];
    $option_value=$o["value"];
    $default=getOption($option_id);

    if (($option_value!=$default[0]["value"] and $default[0]["value"]!="") or ($option_value!=$default[0]["default"] and $default[0]["value"]=="")) {    
      $qry = "INSERT INTO cw_isdn_option (`id_option`,`id_group`,`value`) VALUES ($option_id,$group_id,'$option_value')";
      $res=$db->Execute($qry);
    }
  }
  
  //write to AstConfig or File
  writeMIsdn();

  //write to Extensions_table
  writeIsdnPhoneNumber();
  
  //write the global Variables
  generateGlobalVar();

  if ($ret>0) $ret=$group_id;
  return $ret;
}

// ---- delIsdnGroup(id:int):int --------------------------------------------------

function delIsdnGroup($id,$reload=true) {
  global $db,$pstnin;
  
  //retrieve the queue name
  $g=getIsdnGroup($id);
  $name=$g[0]["name"];

  $qry="DELETE FROM cw_isdn_group WHERE id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Isdn group remove error, mysql DELETE command failed');

  $qry="DELETE FROM cw_isdn_option WHERE id_group='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Isdn group option remove error, mysql DELETE command failed');

  $qry="DELETE FROM cw_isdn_portgroup WHERE `group`='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Isdn port group remove error, mysql DELETE command failed');

  $qry="DELETE FROM cw_isdn_phonenumber WHERE `group`='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Isdn phonenumber remove error, mysql DELETE command failed');
  
  $res=delAstConfig("extensions.conf",$pstnin.$id."%");
  $res=delAstConfig("misdn.conf",$pstnin.$id."%");
  $res=$db->Execute("DELETE FROM extensions_table WHERE context like '".$pstnin.$id."%' ");
  error_log("DELETE FROM extensions_table WHERE context like '".$pstnin.$id."%' ");

  if ($reload==true) {
    //write to AstConfig or File
    writeMIsdn();
  
    //write to Extensions_table
    writeIsdnPhoneNumber();
  }
  
  return 1;
}

// ---- writeMIsdn():int ---------------------------

function writeMIsdn($reload=true) {
  global $db,$pstnin,$safe_asterisk;

  //remove all rows of misdn.conf. It will be regenerated
  $res=delAstConfig("misdn.conf","%");

  //read all the installed port  
  $arrPort=getPort(0);
  
  //insert the GENERAL OPTION  
  $arr=getOption("",OPTION_ISDN);
  if (is_array($arr))
  foreach ($arr as $v) {
    if ($v["value"]=="") $value=$v["default"]; else $value=$v["value"];
    if ($v["commented"]!="1") $res=putAstConfig("misdn.conf", "general", $v["name"], $value);
  }  

  //insert the DEFAULT OPTION  
  $arr=getOption("",OPTION_ISDN_GROUPS);
  if (is_array($arr))
  foreach ($arr as $v) {
    if ($v["value"]=="") $value=$v["default"]; else $value=$v["value"];
    if ($v["commented"]!="1") $res=putAstConfig("misdn.conf", "default", $v["name"], $value);
  }  

  //insert the CUSTOM OPTION  
  $arr=getIsdnGroup("",true);
  if (is_array($arr))
  foreach ($arr as $v) {
    $numberList="";
    $group_id=$v["id"];
    $name=$v["name"];
    $ports=$v["port"];
    
    if (is_array($v["option"]))
    foreach ($v["option"] as $o) {
      $optionDetail=getOption($o["id"]);
      $optionName=$optionDetail[0]["name"];
      $optionValue=$o["value"];
      if ($v["commented"]!="1") $res=putAstConfig("misdn.conf", "$name", $optionName, $optionValue);
    }
    
    //insert the number (msns)
    if (is_array($v["msns"])) {
      foreach ($v["msns"] as $n) {
        //remove the first zero if exists
        if (substr($n["number"],0,1)=="0") $n["number"]=substr($n["number"],1); 
        $numberList.=$n["number"].",";
      }
      $numberList=substr($numberList,0,-1);
      delAstConfig("misdn.conf","$name","msns"); 
      $res=putAstConfig("misdn.conf", "$name", "msns", $numberList);
    }

    //insert the ports
    $portCount=1;
    $portList="";
    if (@is_array($arrPort))
    foreach ($arrPort as $p) {
      if (in_array($p["id"],$ports)) $portList.=$portCount.",";
      $portCount++;
    }  
    $portList=substr($portList,0,-1);
    delAstConfig("misdn.conf","$name","ports"); 
    $res=putAstConfig("misdn.conf", "$name", "ports", $portList);
    
    //insert the context
    delAstConfig("misdn.conf","$name","context"); 
    $res=putAstConfig("misdn.conf", "$name", "context", $pstnin.$group_id);
    
  }  

  if ($reload!==false) {

    //restart asterisk (workaround until chan_mISDN fixed)
    //error_log("sudo $safe_asterisk stop");exec("sudo $safe_asterisk stop",$out);errArr($out);//stop the asterisk
    //error_log("sudo $safe_asterisk start");exec("sudo $safe_asterisk start",$out);errArr($out);//start the asterisk

    //reload the chan_misdn
    $ret=sendCommand("unload chan_misdn.so");
    //error_log($ret);
    //sleep(2);
  
    $ret=sendCommand("load chan_misdn.so");
    //error_log($ret);
    //sleep(2);
  
    //$ret=sendCommand("reload");
    //error_log($ret);
    //sleep(3);
  }
    
  return $ret;
}


// ---- writeIsdnPhoneNumber():int ---------------------------
//      this function is private

function writeIsdnPhoneNumber() {
  global $db,$pstnin,$ivrPrefix;

  //remove all rows of extension.conf. It will be regenerated
  $res=$db->Execute("DELETE FROM extensions_table WHERE context like '".$pstnin."%' ");
  $res=delAstConfig("extensions.conf",$pstnin."%");

  //insert the pstn-in groups  
  $arr=getIsdnGroup(0);
  if (is_array($arr))
  foreach ($arr as $g) {
    $name=$pstnin.$g["id"];
    $numbers=$g["msns"];
    $res=putAstConfig("extensions.conf", $name, "switch", "Realtime/@extensions");
    
    if (is_array($numbers))
    foreach($numbers as $n) {
      $ext=$n["number"];  //0?
      $action=$n["action"];
      $action_option=$n["action_option"];
      $fax=$n["fax"];
      putAction($name,$ext,$action,$action_option,$fax);
    }
  }  
  //reload the extensions
  sendCommand("extensions reload");
}
//******************************************************************************
//******************               ACTION             *********************
//******************************************************************************

// ---- getAction(id:int,showFaxAction:int):Action[] -------------------------------------------

function getAction($id,$showFaxAction=0) {
  global $db;
  $count=0;
  if ($id!="") $condition="WHERE action_id=$id "; else $condition="WHERE fax=0";
  $qry="SELECT DISTINCT action_id as id, name, fax FROM cw_action $condition ORDER BY action_id";
  if ($showFaxAction==1) $qry="SELECT DISTINCT action_id as id, name, fax FROM cw_action WHERE fax=1 ORDER BY action_id limit 0,1";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) { 
    unset($app);
    unset($appdata);
    $qry="SELECT * FROM cw_action WHERE action_id=".$arr["id"]." ORDER BY row";
    $res2=$db->Execute($qry);
    while ($arr2=$res2->FetchRow()) { $app[]=$arr2["app"]; $appdata[]=$arr2["appdata"];} 
    $arr["app"]=$app;
    $arr["appdata"]=$appdata;

    $ret[]=$arr;
  }
  return $ret;
}

// ---- putAction(context:string, ext:string, action: string, action_option:string, fax:string):int -------------------------------------------
//private

function putAction($context,$ext,$action,$action_option,$fax) {
  global $db,$ivrPrefix,$groupPrefix;
  $countAction=1;
  unset($clientList);

  //insert the TIMEOUT extension
  $qry="DELETE FROM extensions_table WHERE context='$context' AND exten='t' AND priority=1 AND app='Hangup' AND appdata=''";
  $db->Execute($qry);
  $qry="INSERT INTO extensions_table (context,exten,priority,app,appdata) VALUES ('$context','t',1,'Hangup','')";
  $db->Execute($qry);

  //insert the INVALID extension
  $qry="DELETE FROM extensions_table WHERE context='$context' AND exten='i' AND priority=1 AND app='Hangup' AND appdata=''";
  $db->Execute($qry);
  $qry="INSERT INTO extensions_table (context,exten,priority,app,appdata) VALUES ('$context','i',1,'Hangup','')";
  $db->Execute($qry);

  if ($action=="0" or $action=="") return;
  switch ($action) {
    case ACTION_GROUP:
      $action_option="\${".$groupPrefix.$action_option."}";
    break;
    case ACTION_QUEUE:
      $arr=getQueue($action_option);
      $action_option=$arr[0]["name"];
    break;
    case ACTION_IVR:
      $action_option=$ivrPrefix.$action_option;
    break;
  }
  $actionArr=getAction($action,$fax);
  if (is_array($actionArr[0]["app"]))
  foreach ($actionArr[0]["app"] as $index=>$app) {
    $appdata=str_replace("\$opt",$action_option,$actionArr[0]["appdata"][$index]);
    $qry="INSERT INTO extensions_table (context,exten,priority,app,appdata) VALUES ('$context','$ext',$countAction,'$app','$appdata')";
    $db->Execute($qry);
    $countAction++;
  }

}

//******************************************************************************
//******************               ISDN PHONENUMBER        *********************
//******************************************************************************

// ---- getIsdnPhoneNumber(id:int):IsdnPhoneNumber[] -----------------------------------------------

function getIsdnPhoneNumber($id) {
  global $db;
  $count=0;
  if ($id!="") $condition="WHERE id=$id ";
  $qry="SELECT * FROM cw_isdn_phonenumber $condition ORDER BY `group`";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow())  $ret[]=$arr;
  return $ret;
}

// ---- updatePort(ports:Port[]):int -------------------------------------------

function updateIsdnPhoneNumber($numbers) {
  global $db;
  $res=true;
  foreach ($numbers as $n) {
    $id=$n["id"];
    $fax=$n["fax"];
    $action=$n["action"];
    $action_option=$n["action_option"];
    $qry="UPDATE cw_isdn_phonenumber SET fax='$fax', action='$action', action_option='$action_option' WHERE id=$id";
    $res&=$db->Execute($qry);
  }
  writeIsdnPhoneNumber();
  return $res;
}



//******************************************************************************
//******************               OPTIONS                 *********************
//******************************************************************************

// ---- getOptionByName(name:string,category:string):Option[] -----------------------------------------------

function getOptionByName($name,$category) {
  global $db;
  $count=0;
  $condition="WHERE name='$name' and category='$category' ";
  $qry="SELECT * FROM cw_option $condition ORDER BY category";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) $ret[]=$arr;
  return $ret;
}

// ---- getOption(id:int,category:string):Option[] -----------------------------------------------

function getOption($id,$category="") {
  global $db;
  $count=0;
  if ($id!="") $condition="WHERE id=$id ";
  else if ($category!="") $condition="WHERE category='$category' ";
  $qry="SELECT * FROM cw_option $condition ORDER BY category";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) $ret[]=$arr;
  return $ret;
}

// ---- putOption(option:Option[]):int ----------------------------------------------

function putOption($option) {
  global $db;
  
  $res=true;

  //insert the queue propriety in the ast_config table  
  foreach ($option as $o) {
    $id=$o["id"];
    $value=$o["value"];
    $commented=$o["commented"];
    if ($commented=="") $commented=0;
    $qry="UPDATE cw_option SET value='$value', commented=$commented WHERE id=$id";
    $res&=$db->Execute($qry);
  }  
  
  return $res;
}




//******************************************************************************
//******************               APPLICATIONS             ********************
//******************************************************************************

// ---- getApplication(id:int):Application[] -----------------------------------

function getApplication($id=0) {
  global $db;
  $count=0;
  if ($id!="") $condition="WHERE id=$id ";
  $qry="SELECT * FROM cw_application $condition ORDER BY name";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) $ret[]=$arr;
  return $ret;
}

//******************************************************************************
//******************               NETWORK                  ********************
//******************************************************************************

// ---- updateNetwork(option:stringArray):int ----------------------------------

function updateNetwork($option) {
  global $db,$networkScript;
  $count=0;
  $hostname=$option[0];
  $domain=$option[1];
  $ip=$option[2];
  $netmask=$option[3];
  $gateway=$option[4];
  $dns1=$option[5];
  $dns2=$option[6];

  if ($hostname=="" or $domain=="" or $ip=="" or $netmask=="" or $gateway=="" or $dns1=="" or $dns2=="") { 
    return 0;
  } else { 
    exec("sudo $networkScript $ip $netmask $gateway  $dns1 $dns2 $hostname $domain",$output,$ret);
    error_log("sudo $networkScript $ip $netmask $gateway  $dns1 $dns2 $hostname $domain");
    errArr($output);
    error_log("RETURN: $ret");
    return 1;
  }
}


//******************************************************************************
//******************               IVR                      ********************
//******************************************************************************


// ---- getIvr(id:int):Ivr[] ---------------------------------------------------

function getIvr($id=0) {
  global $db;
  if ($id!="") $condition="WHERE id=$id ";
  $qry="SELECT * FROM cw_ivr $condition ORDER BY name";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) $ret[]=$arr;
  return $ret;
}

// ---- putIvr(ivr:Ivr):int ----------------------------------------------------

function putIvr($ivr) {
  global $db;
  $ret=1;

  $node=Array("name"=>$ivr["name"],"parent"=>0,"order"=>0);
  $rootNode=putIvrNode($node);
  
  $name=$ivr["name"];
  $qry = "INSERT INTO cw_ivr (`name`,`rootnode`) VALUES ('$name',$rootNode)";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Ivr creation error, mysql INSERT command failed'); 
  $ivr_id=$db->Insert_ID();

  return $ivr_id;
}

// ---- delIvr(id:int):int --------------------------------------------------

function delIvr($id) {
  global $db;
  
  $qry="DELETE FROM cw_ivr WHERE id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Ivr remove error, mysql DELETE command failed');

  return 1;
}



// ---- getIvrNode(id:int):IvrNode[] -----------------------------------------------

function getIvrNode($id=0,$cascading=true) {
  global $db;

  $count=0;
  $ret=array();
  if ($cascading) $qry="SELECT * FROM cw_ivr_node WHERE parent=$id ORDER BY `order`";
  else $qry="SELECT * FROM cw_ivr_node WHERE id=$id";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) { 
    $node_id=$arr["id"];
    $ret[]=$arr;
    $ret=array_merge($ret,getIvrNode($node_id));
  }
  return $ret;
}

// ---- putIvrNode(node:IvrNode):int ----------------------------------------------

function putIvrNode($node) {
  global $db;

  //go to the alterGroup function
  if (isset($node["id"]) and $node["id"]!="") return alterIvrNode($node);

  $ret=1;
  $name=$node["name"];
  $type=$node["type"];
  $parent=$node["parent"];
  $order=$node["order"];

  if ($order==0) {
    if ($parent=="") $parent=0;
    $res=$db->Execute("SELECT COUNT(*) as howmuch FROM cw_ivr_node WHERE parent=$parent");
    $arr=$res->FetchRow();
    $order=$arr["howmuch"]+1;
  }
  $qry="INSERT INTO cw_ivr_node (`name`,`parent`,`order`) VALUES ('$name', '$parent', '$order')";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','IVR creation error, mysql INSERT command failed'); 
  else $node_id=$db->Insert_ID();
  
  if ($ret>0) $ret=$node_id;
  return $ret;
}

// ---- alterIvrNode(node:IvrNode):int ----------------------------------------------

function alterIvrNode($node) {
  global $db;
  $ret=1;

  $id=$node["id"];

  //move the node in the correct position
  $qry="SELECT * from cw_ivr_node WHERE id=$id";
  $res=$db->Execute($qry);
  $arr=$res->FetchRow();
  $oldorder=$arr["order"];
  if ($node["order"]!=$oldorder) {
    $step=abs($node["order"]-$oldorder);
    if (($node["order"]-$oldorder)<0) $direction=1; else $direction=2;
    for ($i=0; $i<$step; $i++) {
      moveIvrNode($id,$direction);
    }
  }

  foreach ($node as $k=>$v) if ($k!="id") $sql.="`$k` = '".$v."',";
  $sql=substr($sql,0,-1);
  $qry="UPDATE cw_ivr_node SET $sql WHERE id=$id";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','IVR modification error, mysql UPDATE command failed'); 

  return $id;
}

// ---- delIvrNode(id:int):int --------------------------------------------------

function delIvrNode($id) {
  global $db;
  
  $qry="DELETE FROM cw_ivr_node WHERE id='$id'";
  $res=$db->Execute($qry);
  if ($res===false) return new soap_fault('Server','','Ivr remove error, mysql DELETE command failed');

  return 1;
}

// ---- moveIvrNode(id:int, direction: int):int --------------------------------------------------
// Direction=1 : up
// Direction=2: down

function moveIvrNode($id,$direction=1) {
  global $db;
  
  //retrieve the current order number
  $qry="SELECT `order`,`parent` FROM cw_ivr_node WHERE id='$id'";
  $res=$db->Execute($qry);
  $arr = $res->FetchRow();
  $order=$arr["order"];
  $parent=$arr["parent"];
  if ($parent=="") $parent=0;
  
  if ($direction==1 and $order>1) {
    $res=$db->Execute("UPDATE cw_ivr_node SET `order`='$order' WHERE `parent`=$parent AND `order`=".($order-1));
    if ($db->Affected_Rows()>0) $res=$db->Execute("UPDATE cw_ivr_node SET `order`=".($order-1)." WHERE id=$id");
  } else if ($direction==2) {
    $res=$db->Execute("UPDATE cw_ivr_node SET `order`=$order WHERE `parent`=$parent AND `order`=".($order+1));
    if ($db->Affected_Rows()>0) $res=$db->Execute("UPDATE cw_ivr_node SET `order`=".($order+1)." WHERE id=$id");
  }
  if ($res===false) return new soap_fault('Server','','Ivr move error, mysql UPDATE command failed');
  else return 1;
}


// ---- compileIvr($ivr_id:int):int --------------------------------------------

function compileIvr($ivr_id) {
  global $db,$ivrPrefix,$ivrScriptConversionPath;

  //clear the old ivr
  clearIvr($ivr_id);

  $ret=exec("$ivrScriptConversionPath &",$out);

  //build the new ivr
  buildIvr($ivr_id);

  //reload the extensions
  sendCommand("reload");

  return 1;
}  

// ---- clearIvr():int --------------------------------------------------
//private

function clearIvr($ivr_id) {
  global $db,$ivrPrefix;
  
  $qry="DELETE FROM extensions_table WHERE context like '".$ivrPrefix.$ivr_id."%'";
  $res=$db->Execute($qry);

  $res=delAstConfig("extensions.conf",$ivrPrefix.$ivr_id."%");

  return 1;
}

// ---- buildIvr():int --------------------------------------------------
//private

function buildIvr($ivr_id,$parent=0) {
  global $db,$ivrPrefix;

  if ($parent==0) {
    $i=getIvr($ivr_id);
    $rootNode=$i[0]["rootnode"];
    $qry="SELECT * FROM cw_ivr_node WHERE `id`=$rootNode";
  } else 
    $qry="SELECT * FROM cw_ivr_node WHERE `parent`='$parent' ORDER BY `key`, `order`";

  $priority=1;
  $startingPriority=1;
  $audioPriority=1;
  $first=true;
  $oldKey="s";
  $res=$db->Execute($qry);
  while ($arr = $res->FetchRow()) {
    $nodeId=$arr["id"];
    $nodeName=$arr["name"];
    $nodeParent=$arr["parent"];
    $nodeKey=$arr["key"];
    if ($nodeKey=="") $nodeKey="s";
    if ($nodeKey!=$oldKey) $priority=1;
    $nodeAudio=$arr["audio"];
    $nodeDial=$arr["dial"];
    $nodeGoto=$arr["goto"];
    $nodeQueue=$arr["queue"];
    $nodeMacro=$arr["macro"];
    $nodeTAudio=$arr["taudio"];
    $nodeTDial=$arr["tdial"];
    $nodeTQueue=$arr["tqueue"];
    $nodeTRepeat=$arr["trepeat"];
    $nodeIAudio=$arr["iaudio"];
    $nodeIDial=$arr["idial"];
    $nodeIQueue=$arr["iqueue"];
    $nodeIRepeat=$arr["irepeat"];
    
    //retrieve the parent node name
    $qry="SELECT * FROM cw_ivr_node WHERE `id`='$nodeParent'";
    $resp=$db->Execute($qry);
    $arrp=$resp->FetchRow();
    $nodeParentContext=$ivrPrefix.$ivr_id.$arrp["name"];
    $nodeContext=$ivrPrefix.$ivr_id.$nodeName;

    //check if there are children
    $qry="SELECT * FROM cw_ivr_node WHERE `parent`='$nodeId'";
    $resp=$db->Execute($qry);
    if ($resp->RecordCount()>0) $nodeFolder=true;
    else $nodeFolder=false;

    if ($first) {
      //insert the group in the ast_config
      $resAstConfig=putAstConfig("extensions.conf","$nodeParentContext","switch","Realtime/@extensions");
      if ($resAstConfig===false) $ret=$ret and 0; else $ret=$ret and 1;
    }
    if ($nodeAudio!="")  insertIvrAction($ivr_id, $nodeParentContext, "s", $audioPriority, IVR_BACKGROUND, $nodeAudio);


    if (!$nodeFolder) {
      if ($nodeDial!=""  and $nodeDial!=0)  insertIvrAction($ivr_id, $nodeParentContext, $nodeKey, $priority, IVR_DIAL,    $nodeDial);
      if ($nodeQueue!="" and $nodeQueue!=0) insertIvrAction($ivr_id, $nodeParentContext, $nodeKey, $priority, IVR_ENQUEUE, $nodeQueue);
      if ($nodeMacro!="" and $nodeMacro!=0) insertIvrAction($ivr_id, $nodeParentContext, $nodeKey, $priority, IVR_MACRO,   $nodeMacro);
      if ($nodeGoto!="")                    insertIvrAction($ivr_id, $nodeParentContext, $nodeKey, $priority, IVR_GOTO,    $nodeGoto);
    } else {
      //goto children
      if ($nodeKey=="s") insertIvrAction($ivr_id, $nodeParentContext, $nodeKey, $audioPriority, IVR_GOTO, $nodeId);
      else insertIvrAction($ivr_id, $nodeParentContext, $nodeKey, $priority, IVR_GOTO, $nodeId);
      //if ($nodeAudio!="") insertIvrAction($nodeContext, "s", $startingPriority, IVR_BACKGROUND, $ivrPath.$nodeAudio);
    
      //timeout
      $startingPriority=1;
      if ($nodeTAudio!="")                    insertIvrAction($ivr_id, $nodeContext, "t", $startingPriority, IVR_BACKGROUND, $nodeTAudio);
      if ($nodeTDial!="" and $nodeTDial!=0)   insertIvrAction($ivr_id, $nodeContext, "t", $startingPriority, IVR_DIAL, $nodeTDial);
      if ($nodeTQueue!="" and $nodeTQueue!=0) insertIvrAction($ivr_id, $nodeContext, "t", $startingPriority, IVR_ENQUEUE, $nodeTQueue);
      if ($nodeTRepeat==1)                    insertIvrAction($ivr_id, $nodeContext, "t", $startingPriority, IVR_GOTO, $nodeId);

      //invalid
      $startingPriority=1;
      if ($nodeIAudio!="")                    insertIvrAction($ivr_id, $nodeContext, "i", $startingPriority, IVR_BACKGROUND, $nodeIAudio);
      if ($nodeIDial!="" and $nodeIDial!=0)   insertIvrAction($ivr_id, $nodeContext, "i", $startingPriority, IVR_DIAL, $nodeIDial);
      if ($nodeIQueue!="" and $nodeIQueue!=0) insertIvrAction($ivr_id, $nodeContext, "i", $startingPriority, IVR_ENQUEUE, $nodeIQueue);
      if ($nodeIRepeat==1)                    insertIvrAction($ivr_id, $nodeContext, "i", $startingPriority, IVR_GOTO, $nodeId);
    }
    
    buildIvr($ivr_id,$nodeId);  //recurse in the other branch   

    $oldKey=isset($key)?$key:"";
    $first=false;
  }
}

//----- insertIvrAction(context:string, exten: string, priority:int, app:string, appdata:string) : int
// this function is private
  function insertIvrAction ($ivr_id, $context, $exten, &$priority, $type, $val) {
    global $ivrPrefix,$ivrStartingDir,$db;
    $rawExtensionArray=getExtensionType($type,0);
    $rawExtension=$rawExtensionArray[0];
    $rawAppData=$rawExtension["appdata"];

    //get the next priority order
    $qry="SELECT * FROM extensions_table WHERE context='$context' AND exten='$exten' AND priority=$priority ORDER BY priority";
    $res=$db->Execute($qry);
    $arr=$res->FetchRow();
    if ($res->RecordCount()>0) $priority=$arr["priority"]+1;

    switch ($type) {
      case IVR_BACKGROUND:
        $app=$rawExtension["app"];
        $val=$ivrStartingDir.substr(basename($val),0,strpos($val,".")-strlen($val));
        $appdata=str_replace("\$data",$val, $rawAppData);
      break;
      case IVR_DIAL:
        $app=$rawExtension["app"];
        $ret=getClient($val,0);
        $name=$ret[0]["peer"]["name"];
        $appdata=str_replace("\$data", "SIP/$name|10|tw", $rawAppData);
      break;
      case IVR_ENQUEUE:
        $app=$rawExtension["app"];
        $ret=getQueue($val);
        $name=$ret[0]["name"];
        $appdata=str_replace("\$data", "enqueue|$name|2", $rawAppData);
      break;
      case IVR_MACRO:
        $actionArr=getAction($val);
        $app=$actionArr[0]["app"][0];
        $appdata=$actionArr[0]["appdata"][0];
      break;
      case IVR_GOTO:
        $app=$rawExtension["app"];
        $ret=getIvrNode($val, false);
        $name=$ret[0]["name"];
        $appdata=str_replace("\$data", $ivrPrefix.$ivr_id."$name|s|1", $rawAppData);
      break;
    }


    $extensionArray=Array();
    $extensionArray["context"]=$context;
    $extensionArray["exten"]=$exten;
    $extensionArray["priority"]=$priority;
    $extensionArray["app"]=$app;
    $extensionArray["appdata"]=$appdata;
    $ret=putExtension($extensionArray);
    
    //echo "<tr>";
    //echo "<td>$context</td>";  
    //echo "<td>$exten</td>";  
    //echo "<td>$priority</td>";  
    //echo "<td>$app</td>";  
    //echo "<td>$appdata</td>";
    //echo "</tr>\n";  
    ++$priority;
    
  }
  
  
//******************************************************************************
//******************               SIP                      ********************
//******************************************************************************
  
  
// ---- writeSIP():int ---------------------------

function writeSIP($reload=true) {
  global $db,$pstnin,$safe_asterisk;

  //remove all rows of sip.conf. It will be regenerated
  $res=delAstConfig("sip.conf","%");

  //insert the GENERAL OPTION  
  $arr=getOption("",OPTION_SIP);
  if (is_array($arr))
  foreach ($arr as $v) {
    if ($v["value"]=="") $value=$v["default"]; else $value=$v["value"];
    if ($v["commented"]!="1") $res=putAstConfig("sip.conf", "general", $v["name"], $value);
  }  
    
  // register the SIP Provider
  $res=getResource(0,SIP_PROVIDER);
  delAstConfig("sip.conf","general","register"); 
  if (is_array($res))
  foreach ($res as $k=>$v) {
    $value=$v["peer"]["username"].":".$v["peer"]["secret"]."@".$v["peer"]["host"];
    if ($v["peer"]["port"]!="") $value.=":".$v["peer"]["port"];
    $res=putAstConfig("sip.conf", "general", "register", $value);
  }

  if ($reload!==false) $ret=sendCommand("sip reload");
    
  return $ret;
}
  
//******************************************************************************
//******************               IAX                      ********************
//******************************************************************************
  
  
// ---- writeIAX():int ---------------------------

function writeIAX($reload=true) {
  global $db,$pstnin,$safe_asterisk;

  //remove all rows of sip.conf. It will be regenerated
  $res=delAstConfig("iax.conf","%");

  //insert the GENERAL OPTION  
  $arr=getOption("",OPTION_IAX);
  if (is_array($arr))
  foreach ($arr as $v) {
    if ($v["value"]=="") $value=$v["default"]; else $value=$v["value"];
    if ($v["commented"]!="1") $res=putAstConfig("iax.conf", "general", $v["name"], $value);
  }  
    
  // register the IAX Provider
  //$res=getResource(0,IAX_PROVIDER);
  //delAstConfig("iax.conf","general","register"); 
  //if (is_array($res))
  //foreach ($res as $k=>$v) {
  //  $value=$v["peer"]["username"].":".$v["peer"]["secret"]."@".$v["peer"]["host"];
  //  if ($v["peer"]["port"]!="") $value.=":".$v["peer"]["port"];
  //  $res=putAstConfig("iax.conf", "general", "register", $value);
  //}

  if ($reload!==false) $ret=sendCommand("iax2 reload");
    
  return $ret;
}
  
  

//******************************************************************************
//******************               INITIALIZE               ********************
//******************************************************************************

// ---- initialize():int ----------------------------------------------------

function initialize($genKeys) {
  global $db,$synDbUser,$synDbPassword,$safe_asterisk,$misdn_sh;
  global $astGenKeyScript,$keyName,$sandBox,$inkeyScript,$synDbName;

  //stop Asterisk
  exec("sudo $safe_asterisk stop",$out);
  errArr($out);
  
  //stop mISDN driver
  exec("sudo $misdn_sh stop",$out);
  errArr($out);
  
  //remove all the tables 
  //TODO: remove only voiceone tables
  $tables=$db->MetaTables('TABLES');
  if (is_array($tables))
  foreach ($tables as $t) {
    $db->Execute("DROP TABLE `$t`");
  } 

  //write the right file permission
  exec("sudo config/script/install.sh",$out);
  errArr($out);
  
  //insert the database structures
  exec("cat config/backup/structure.sql | mysql --user=$synDbUser --password=$synDbPassword $synDbName",$out);
  errArr($out);

  //insert the database start up datas
  //exec("cat config/backup/data-it.sql | mysql --user=$synDbUser --password=$synDbPassword asterisk",$out);
  exec("cat config/backup/data-international.sql | mysql --user=$synDbUser --password=$synDbPassword $synDbName",$out);
  errArr($out);

  //read the extensions.conf and put it into the Ast_config table
  $lines = file("config/backup/extensions.conf");
  $filename=basename("extensions.conf");
  createAstConfig($lines,$filename);
 
  //complete the ast_config table with the phoneNumber
  $ext=getPhoneNumber(0);
  if (is_array($ext))
  foreach($ext as $v) {
    $ret=putPhoneNumber($v);
  }
  
  //complete the ast_config table with the rights
  $ext=getRight(0);
  if (is_array($ext))
  foreach($ext as $v) {
    $ret=putRight($v);
  }
  
  //write the mISDN configuration 
  writeMIsdn(false);  

  //write the SIP configuration 
  writeSIP(false);  

  //write the SIP configuration 
  writeIAX(false);  

  //Generate the private and public key and move it in the right position
  if ($genKeys==1) {
    exec("sudo $astGenKeyScript $sandBox"."$keyName",$output,$retScript);
    exec("sudo $inkeyScript $keyName",$output,$retScript);
  }
  
  error_log("Setup Completed");
  //the asterisk is now DOWN. It will be started when the first isdn card is 
  //installed.

  return $ret;
}

  
  

//******************************************************************************
//******************               DIRECTORY               ********************
//******************************************************************************

// ---- getDirectory():directory[] -----------------------------------

function getDirectory() {
  global $db;

  $start=false;
  $peers=sendCommand("sip show peers");
  if ($peers!="") {
    $lines=split("\n",$peers);
    foreach ($lines as $l) {
      if (strpos($l,"online")!==false) $start=false;
      if ($start) {
        $infos=split("[ ]+",$l);
        $userArr=split("/",$infos[0]);
        $username=$userArr[1];
        if (strpos($l,"UNKNOWN")!==false) $peerInfo[$username]="UNKNOWN";
        if (strpos($l,"Unmonitored")!==false) $peerInfo[$username]="Unmonitored";
        if (strpos($l,"OK")!==false) $peerInfo[$username]="OK";
      }
      if (strpos($l,"Name")!==false) $start=true;
    }
  } 

  $ext=getClient(0);
  if (is_array($ext))
  foreach($ext as $v) {
    $name=$v["peer"]["callerid"];
    $username=$v["username"];
    if (isset($peerInfo[$v["username"]])) $status=$peerInfo[$username];
    else $status="UNKNOWN";
    $arr=array("name"=>"$name", "username"=>"$username", "status"=>"$status");
    $ret[]=$arr;
  }
  return $ret;
}


//******************************************************************************
//******************               USER                     ********************
//******************************************************************************

// ---- getUser(id:int):user[] -----------------------------------

function getUser($id) {
  global $db;

  if ($id!="") $condition=" WHERE id=$id ";
  $qry="SELECT * FROM cw_user $condition";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) {
    $id=$arr["id"];
    $type=$arr["type"];
    $lang=$arr["lang"];
    $entity_id=$arr["entity_id"];
    if ($entity_id!=0) {
      $client=getClient($entity_id);
      $c=$client[0];
      $fullname=$c["name"]." ".$c["surname"];
      $username=$c["username"];
      $password=$c["password"];
      $exten=$c["peer"]["name"];
      $protocol=$c["peer"]["protocol"];
      $entity_id=$entity_id;
    } else {
      $username=$arr["username"];
      $password=$arr["password"];
      $entity_id=0;
    }
    $ret[]=array("id"=>$id, "fullname"=>$fullname, "username"=>$username, "password"=>$password, "lang"=>$lang, "entity_id"=>$entity_id, "exten"=>$exten, "protocol"=>$protocol, "type"=>$type);
  }
  return $ret;
}

// ---- putUser(user:UserArray):int -----------------------------------

function putUser($user) {
  global $db;
  $id="";
  $id_value="";
  
  //if already exists, delete it
  if (isset($user["id"]) and $user["id"]!="") {
    delUser($user["id"],false);
    $id="id,";
    $id_value=$user["id"].",";
  }
  
  if ($user["type"]=="") $user_type=USER_STANDARD;
  
  //insert the client credentials
  $qry="INSERT INTO cw_user ($id username,password,lang,type,entity_id) ";
  $qry.="VALUES ($id_value \"{$user['username']}\",\"{$user['password']}\",\"{$user['lang']}\",\"{$user['type']}\",\"{$user['entity_id']}\")";
  $res=$db->Execute($qry);
  if ($res===false) $ret=0; 
  elseif ($user["id"]=="") $ret=$db->Insert_ID();
  else $ret=$user["id"];

  return $ret;
}

// ---- delUser(id:int):int --------------------------------------------------

function delUser($id) {
  global $db;

  //remove the user
  $qry="DELETE FROM cw_user WHERE id=".$id;
  $db->Execute($qry);
  
  return 1;
}

// ---- checkUser(username:string, password:string):int --------------------------------------------------
// PS: password must be an md5 password

function checkUser($username, $password) {
  global $db;
  $ret=0;
  $u=getUser(0);
  if (is_array($u))
  foreach($u as $user) {
    if ($user["username"]==$username AND md5($user["password"])==$password) $ret=$user["id"];
  }
  return $ret;
}

// ---- viewAstConfigFilename():string[] ---------------------------------------

function viewAstConfigFilename() {
  global $db;
  $qry="SELECT DISTINCT filename FROM ast_config";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) $ret[]=$arr["filename"];
  return $ret;
}

// ---- viewAstConfig(filename:string):string ---------------------------------------

function viewAstConfig($f) {
  global $db;
  $qry="SELECT DISTINCT filename FROM ast_config WHERE filename='$f'";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) {
    $filename=$arr["filename"];

    $qry="SELECT DISTINCT category FROM ast_config WHERE filename='$filename' ORDER BY cat_metric";
    $res2=$db->Execute($qry);
    while ($arr=$res2->FetchRow()) {
      $category=$arr["category"];
      $ret.= "\n";
      $ret.= "[".$category."]\n";
      
      $qry="SELECT * FROM ast_config WHERE filename='$filename' AND category='$category' ORDER BY var_metric";
      $res3=$db->Execute($qry);
      while ($arr=$res3->FetchRow()) {
        $var_name=$arr["var_name"];
        $var_val=$arr["var_val"];
        $comment=$arr["comment"];
        $commented=$arr["commented"];
        if ($var_name!="" and $commented!=1) $ret.= "$var_name = $var_val";
        if ($var_name!="" and $commented==1) $ret.= "; $var_name = $var_val";
        if ($comment!="" and $var_name!="") $ret.= "\t ;$comment";
        if ($comment!="" and $var_name=="") $ret.= ";$comment";
        $ret.="\n";
      }
    }
  }
  //error_log($ret);
  return $ret;
}

// ---- createAstConfig(lines:stringArray, filename:string):int ----------------

function createAstConfig($lines,$filename) {
  global $db;
  $cat_metric=-1;
  $var_metric=0;

  // remove all the old records about this $filename
  $qry="DELETE FROM ast_config WHERE filename='$filename'";
  $res=$db->Execute($qry);

  // Ciclo attraverso l'array, si visualizzer il sorgente come html ed i numeri di linea
  foreach($lines as $line_num => $line) {
    $line=trim($line);
    if ($line{0}=="") continue;
    if ($line{0}==";") {
      $comment=str_replace("\"","'",trim(substr(trim($line),1)));
      $var_name="";
      $var_val="";
      $commented=1;
      $var_metric++;
      //echo "<span color='green'>$comment</span><br>";
    } else {
      $commented="0";
      if ($line{0}=="[") {
        $arr_comm=split(";",trim($line));
        $category=substr(trim($arr_comm[0]),1,strlen(trim($arr_comm[0]))-2);
        $comment=trim($arr_comm[1]);
        //echo "<h1>$category</h1>";
        $cat_metric++;
        $var_metric=-1;
        continue;
      } else {
        $arr=split("=|=>",$line);
        $var_name=trim($arr[0]);
        unset($arr[0]);
        $arr_comm=split(";",trim(implode("=", $arr)));
        $var_val=trim($arr_comm[0]);
        $comment=trim($arr_comm[1]);
        $var_metric++;
        //echo "<b>$var_name</b> || <i>$var_val</i><br>";
      }  
    }
    $var_name=str_replace("\"","\\\"",$var_name);
    $var_val=str_replace("\"","\\\"",$var_val); 
          
    $qry="INSERT INTO ast_config (cat_metric,var_metric,commented,filename,category,var_name,var_val,comment)";
    $qry.="VALUES ($cat_metric,$var_metric,$commented,\"$filename\",\"$category\",\"$var_name\",\"$var_val\",\"$comment\")";
    $res=$db->Execute($qry);
    if ($res==false) error_log ("Errore: $qry"); 
    
  }
  return 1;
}

// ---- getPublicKey():string ----------------

function getPublicKey() {
  global $db,$keyName;
  //$filename="/var/lib/asterisk/key/".$keyName.".pub";
  $filename="sandbox/".$keyName.".pub";
  $hi = fopen($filename,"r");
  $ret = fread($hi,filesize($filename));
  fclose($hi);
  
  //$ret=file_get_contents ("/var/lib/asterisk/key/".$keyName".pub");
  return $ret; 
}

// ---- stats(source:String, type:String, search:String, from:String, to:String, orderBy:String, page:Int ):CdrArray ----------------

function stats($request) {
  global $db;
  $ENTRIES_PER_PAGE=20;
  
  $source = trim($request["source"]);
  $type=$request["type"];
  $search=$request["search"];
  $from=$request["from"];
  $to=$request["to"];
  $orderBy=$request["orderBy"];
  $page=$request["page"];

  errArr($request); 
  //where statement
  if ($source!="") {
    if (($type=="a" or $type=="r") ) $where.="OR  SUBSTRING(dstchannel FROM 1 FOR INSTR(dstchannel,'-')-1 )='$source' ";
    if (($type=="a" or $type=="r") and $search!="") $where.="AND src='$search' ";
    if (($type=="a" or $type=="d") ) $where.="OR  SUBSTRING(channel FROM 1 FOR INSTR(channel,'-')-1 )='$source' ";
    if (($type=="a" or $type=="d") and $search!="") $where.="AND dst='$search' ";
  } else {
    if ($search!="") $where.="AND (src='$search' or dst='$search') ";
  }
  if ($from!="") $where.="AND calldate>='$from' ";
  if ($to!="") $where.="AND calldate<='$to' ";

  //order by statment 
  if ($orderBy=="dateDesc") $orderBy="ORDER BY calldate DESC";
  else if ($orderBy=="dateAsc") $orderBy="ORDER BY calldate";
  else if ($orderBy=="durationDesc") $orderBy="ORDER BY duration DESC";
  else if ($orderBy=="durationAsc") $orderBy="ORDER BY duration";

  //pagination
  if ($page=="") $page=1;
  $entries=$ENTRIES_PER_PAGE*(intval($page)-1);
  $limit=" LIMIT $entries,$ENTRIES_PER_PAGE";

  //Query Execution
  $where=trim(substr($where,3));
  if ($where!="") $where="WHERE ".$where;  
  $qry="SELECT * FROM cdr $where $orderBy $limit";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) {
    $answer=substr($arr["dstchannel"],0,strrpos($arr["dstchannel"],"-"));
    $caller=substr($arr["channel"],0,strrpos($arr["channel"],"-"));
    if ($answer==$source) {
      if ($arr["clid"]=="") $arr["clid"]="Anonymous";
      $ret["received"]=$arr["clid"];
      $ret["dialed"]="";
      $ret["channel"]=$arr["channel"];
    }
    if ($caller==$source) {
      $ret["received"]="";
      $ret["dialed"]=$arr["dst"];
      $ret["channel"]=$arr["src"];
    }
    if ($source=="") {  //show all the calls 
      if ($arr["clid"]=="") $arr["clid"]="Anonymous";
      $ret["received"]=$arr["clid"];
      $ret["dialed"]=$arr["dst"];
    }
    $ret["entity"]=$source;
    $ret["calldate"]=$arr["calldate"];
    $ret["duration"]=$arr["duration"];

    $result[]=$ret;
  }

  //error_log($qry);
  
  return $result; 
}

  
//******************************************************************************
//******************               PRIVATE                  ********************
//******************************************************************************

function test() {
 $ret=sendCommand("reload");
 print_r($ret);
 return;
}

// ---- generateGlobalVar(groups:int[]): int 
//create the global var in the Ast_Config

function generateGlobalVar($groups="") {
  global $db,$groupPrefix;

  //CREATE THE GROUP OF ENTITY VARIABLE
  $qry="SELECT * FROM cw_group";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) {
    $group_name=$arr["name"];
    $group_id=$arr["id"];
    $str="";
    $qry="SELECT * FROM cw_entity e, cw_group_entity ge WHERE ge.entity_id=e.id AND ge.group_id=".$group_id.$where;
    $resEntity=$db->Execute($qry);
    while ($arr=$resEntity->FetchRow()) {
      $entityId=$arr["entity_id"];
      $groupId=$arr["group_id"];
      $type=$arr["type"];
      $name=getEntityName($entityId);      
      switch ($type) {
        case SIP_CLIENT:
        case SIP_PROVIDER: $tech="SIP/"; break; 
        case IAX_CLIENT:
        case IAX_DEPARTMENT: $tech="IAX2/"; break;
        case ISDN_PROVIDER:
        case PHONENUMBER: $tech="mISDN/"; break;
      }
      $str.=$tech.$name."&";
      if ($type==SIP_PROVIDER) $trunkSIP.=$tech.$name."&";
    }
    $app=$groupPrefix.$group_id;
    $appdata=substr($str,0,-1);
    $resAstConfig=delAstConfig("extensions.conf","globals",$app);
    $resAstConfig=putAstConfig("extensions.conf","globals",$app,$appdata);
  }


  //CREATE THE TRUNK VARIABLE
  $ret=getIsdnGroup(0);
  $str="";
  if (is_array($ret)) 
  foreach($ret as $v) {
    $id=$v["id"];
    $name=$v["name"];
    $order=$v["trunk_order"];
    $str.="mISDN/g:$name&";
  }
  $str.=$trunkSIP;
  $app="TRUNK";
  $appdata=substr($str,0,-1);
  $resAstConfig=delAstConfig("extensions.conf","globals",$app);
  $resAstConfig=putAstConfig("extensions.conf","globals",$app,$appdata);


}

// ---- putAstConfig($file:string, $context:string, $var:string, $var_data:string): int 

function putAstConfig($file,$context,$var,$var_data) {
  global $db;

  //check if any other same astconfig entry is already into the table
  $qry="SELECT * FROM ast_config WHERE filename=\"$file\" AND category=\"$context\" AND var_name=\"$var\" AND var_val=\"$var_data\"";
  $res=$db->Execute($qry);
  if ($res->RecordCount()>0) {
    $arr=$res->FetchRow();
    return $arr["id"];  
  }

  //calculate the var_metric
  $qry="SELECT * FROM ast_config WHERE filename='$file' and category='$context'";
  $res=$db->Execute($qry);
  $count=$res->RecordCount();
  $arrCat=$res->FetchRow();
  if ($count>0) {
    $qry="SELECT MAX(var_metric) as maxvar FROM ast_config WHERE filename='$file' and category='$context'";
    $res=$db->Execute($qry);
    $arr=$res->FetchRow();
    $var_metric=$arr["maxvar"]+1;
    $cat_metric=$arrCat["cat_metric"];
  } else {
    $qry="SELECT MAX(cat_metric) as maxcat FROM  ast_config WHERE  filename='$file'";
    $res=$db->Execute($qry);
    $arr=$res->FetchRow();
    $cat_metric=$arr["maxcat"]+1;    
    $var_metric=0;
  }    

  $var=str_replace("\"","\\\"",$var);
  $var_data=str_replace("\"","\\\"",$var_data); 
  
  $qry="INSERT INTO ast_config (cat_metric,var_metric,commented,filename,category,var_name,var_val)";
  $qry.="VALUES($cat_metric,$var_metric,0,\"$file\",\"$context\",\"$var\",\"$var_data\")";
  $res=$db->Execute($qry);
  $astconfig_id=$db->Insert_ID();
  return $astconfig_id;
}

// ---- delAstConfig($file:string, $context:string, $var:string): int 

function delAstConfig($file,$category,$var_name="",$var_val="") {
  global $db;
  $qry="DELETE FROM ast_config WHERE filename=\"$file\" AND category like \"$category\" ";
  if ($var_name!="")  $qry.=" AND var_name  like \"".$var_name."\"";
  if ($var_val!="") $qry.=" AND var_val like \"".$var_val."\"";
  $res=$db->Execute($qry);
  return $res;
}


// ---- sendCommand ($cmd:string):int 
// send a command with the Asterisk API Manager interface
function sendCommand($cmd) {
  global $floapi,$API_user,$API_pass,$API_host;
  
  // Connect to asterisk via API
  // Create the object.

  $floapi = @new floAPI($API_user, $API_pass, $API_host);
  
  if ($floapi->socket!="") {
    // Run a test command (sip show peers).
    $ret= $floapi->request("COMMAND", array("COMMAND" => $cmd));
  
    // Close the connection.
    //if (strpos($cmd,"restart")===false ) $floapi->close();
    $floapi->close();

    return $ret;
  } else return 0; 
}

//if (!function_exists("file_put_contents")) {
   function file_put_contents($filename,$content,$mode="w") {
       if(!$file = @fopen($filename, $mode)) return false;
       if($file) {
           if(!@fwrite($file,$content)) return false;
           fclose($file);
           @chmod($file, 0755);
       }
       return true;
   }
//}

  function errArr($arr) {
    if (count($arr)==0) error_log("ok!");
    else {
      ob_start();
        print_r($arr);
      $contents=ob_get_contents();
      ob_end_clean();
      error_log($contents);     
    }
    unset($arr);
    return;
  }
?>